/*
 *  Created on 28.11.2003
 *
 */
package seco.semcocoon;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import seco.util.Base64;

/**
 *@author     jiemakel
 *@created    4. joulukuuta 2003
 */
public class HTTPQueryHelper {

    /**
     *  Description of the Method
     *
     *@param  serverURL      Description of the Parameter
     *@param  username       Description of the Parameter
     *@param  password       Description of the Parameter
     *@return                Description of the Return Value
     *@exception  Exception  Description of the Exception
     */
    public static InputStream executeGETQuery(URL serverURL, String username, String password) throws Exception {
        HttpURLConnection connection = getConnection(serverURL, username, password);
        connection.setDoInput(true);
        return connection.getInputStream();
    }


    /**
     *  Description of the Method
     *
     *@param  serverURL      Description of the Parameter
     *@param  queryString    Description of the Parameter
     *@param  username       Description of the Parameter
     *@param  password       Description of the Parameter
     *@return                Description of the Return Value
     *@exception  Exception  Description of the Exception
     */
    public static InputStream executePOSTQuery(URL serverURL, Map parameters, String username, String password) throws Exception {
        HttpURLConnection connection = null;
        try {
            connection = getConnection(serverURL, username, password);
        } catch (IOException e) {
            throw new Exception("IOException opening connection: " + e.getMessage());
        }
        connection.setDoOutput(true);
        connection.setDoInput(true);
        connection.setRequestMethod("POST");
        connection.setRequestProperty("Content-type", "application/x-www-form-urlencoded");
        StringBuffer queryString=new StringBuffer();
		Set entrySet = parameters.entrySet();
		Iterator i = entrySet.iterator();
		while (i.hasNext()) {
			Map.Entry me = (Map.Entry)i.next();
			queryString.append((String)me.getKey());
			queryString.append("=");
			queryString.append(URLEncoder.encode((String)me.getValue(),"UTF-8"));
			if (i.hasNext()) queryString.append("&");
		}
        connection.setRequestProperty("Content-Length", "" + queryString.length());

        PrintWriter toServer = null;
        try {
            toServer = new PrintWriter(connection.getOutputStream());
        } catch (IOException e) {
            throw new Exception("IOException outputting to connection: " + e.getMessage());
        }
        toServer.write(queryString.toString());
        toServer.flush();
        toServer.close();

        InputStream inputStream = null;
        try {
            inputStream = connection.getInputStream();
        } catch (IOException e) {
            throw new Exception("IOException inputting from connection: " + e.getMessage());
        }
        return inputStream;
    }


    /**
     *  Description of the Method
     *
     *@param  serverURL      Description of the Parameter
     *@param  queryString    Description of the Parameter
     *@param  username       Description of the Parameter
     *@param  password       Description of the Parameter
     *@return                Description of the Return Value
     *@exception  Exception  Description of the Exception
     */
    public static InputStream executeXMLQuery(URL serverURL, String queryString, String username, String password) throws Exception {
        HttpURLConnection connection = null;
        try {
            connection = getConnection(serverURL, username, password);
        } catch (IOException e) {
            throw new Exception("IOException opening connection:" + e.getMessage());
        }
        connection.setDoOutput(true);
        connection.setDoInput(true);
        connection.setRequestProperty("Content-type", "text/xml");
        connection.setRequestProperty("Content-Length", "" + queryString.length());
//        System.out.println("Query: "+queryString);
        PrintWriter toServer = null;
        try {
            toServer = new PrintWriter(connection.getOutputStream());
        } catch (IOException e) {
            throw new Exception("IOException outputting to connection: " + e.getMessage());
        }
        toServer.write(queryString);
        toServer.flush();
        toServer.close();

        InputStream inputStream = null;
        try {
            inputStream = connection.getInputStream();
        } catch (IOException e) {
            throw new Exception("IOException inputting from connection: " + e.getMessage());
        }
        return inputStream;
    }


    /**
     *  Gets the connection attribute of the HTTPQueryHelper class
     *
     *@param  serverURL      Description of the Parameter
     *@param  username       Description of the Parameter
     *@param  password       Description of the Parameter
     *@return                The connection value
     *@exception  Exception  Description of the Exception
     */
    public static HttpURLConnection getConnection(URL serverURL, String username, String password) throws Exception {
        HttpURLConnection connection = (HttpURLConnection) serverURL.openConnection();
        if (username != null && password != null) {
            String toEncode = username + ":" + password;
            connection.setRequestProperty("Authorization",
                    "Basic " + Base64.encodeBytes(toEncode.getBytes()));
        }
        return connection;
    }
}


