/*
 *  Created on 21.11.2003
 *
 */
package seco.semcocoon.transformation;

import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;
import java.net.URL;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import org.apache.avalon.framework.configuration.Configurable;
import org.apache.avalon.framework.configuration.Configuration;
import org.apache.avalon.framework.configuration.ConfigurationException;
import org.apache.avalon.framework.parameters.ParameterException;
import org.apache.avalon.framework.parameters.Parameters;
import org.apache.cocoon.ProcessingException;
import org.apache.cocoon.caching.CacheableProcessingComponent;
import org.apache.cocoon.environment.SourceResolver;
import org.apache.excalibur.source.SourceValidity;
import org.apache.excalibur.source.impl.validity.NOPValidity;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

import seco.semcocoon.HTTPQueryHelper;
import seco.semcocoon.transformation.NullTransformer;

/**
 *@author     jiemakel
 *@created    4. joulukuuta 2003
 */
public class OntodellaServerTransformer extends NullTransformer implements Configurable, CacheableProcessingComponent {

    /**
     *  Description of the Field
     */
    protected Configuration[] locations = null;
    /**
     *  Description of the Field
     */
    protected String passwordDefault = null;
    /**
     *  Description of the Field
     */
    protected String usernameDefault = null;
    
    protected String parameterElement= null;
    protected Map parameterAttributes= null;


    /**
     *  Description of the Method
     *
     *@param  conf                        Description of the Parameter
     *@exception  ConfigurationException  Description of the Exception
     */
    public void configure(Configuration conf)
             throws ConfigurationException {
        locations = conf.getChildren("location");
        try {
            usernameDefault = conf.getChild("username").getValue();
            passwordDefault = conf.getChild("password").getValue();
        } catch (ConfigurationException e) {
            usernameDefault = null;
            passwordDefault = null;
        }
    }

	public Serializable getKey() {
		StringBuffer locationString = new StringBuffer();
		for (int i=0;i<locations.length;i++) {
			try {
				locationString.append(locations[i].getValue());
			} catch (ConfigurationException e) {
			}
		}
		return parameters.getParameter("param","-")+parameters.getParameter("function","-")+parameters.getParameter("username","-")+parameters.getParameter("password","-")+parameters.getParameter("location","-")+usernameDefault+passwordDefault+locationString;
	}
	
	public SourceValidity getValidity() {
		return NOPValidity.SHARED_INSTANCE;
	}
	
	public void setup(SourceResolver resolver, Map objectModel, String src, Parameters par) throws SAXException,IOException,ProcessingException {
		super.setup(resolver,objectModel,src,par);
		try {
			String[] temp = parameters.getParameter("param").split("/");
			parameterElement = temp[0];
			parameterAttributes = new HashMap();
			String[] temp2 = temp[1].split(",");
			for (int i=0;i<temp2.length;i++) {
				String[] temp3 = temp2[i].split("=");
				parameterAttributes.put(temp3[0],temp3[1]);
			}
		} catch (ParameterException e) {
			throw new ProcessingException("No parameter definition given in sitemap!",e);
		}
	}
    /**
     *  Description of the Method
     *
     *@param  uri               Description of the Parameter
     *@param  name              Description of the Parameter
     *@param  qName             Description of the Parameter
     *@param  atts              Description of the Parameter
     *@exception  SAXException  Description of the Exception
     */
    public void startElement(String uri, String name, String qName, Attributes atts) throws SAXException {
    	if (parameterElement.equals(qName)) {
			InputStream inputStream = null;
			String username = null;
			String password = null;
			try {
				username = parameters.getParameter("username");
				password = parameters.getParameter("password");
			} catch (ParameterException e) {
				username = usernameDefault;
				password = passwordDefault;
			}
			Set entrySet = parameterAttributes.entrySet();
			Iterator it = entrySet.iterator();
			HashMap params = new HashMap();
			while (it.hasNext()) {
				Map.Entry me = (Map.Entry)it.next();
				params.put(me.getValue(),atts.getValue((String)me.getKey()));
			}
            try {
                inputStream = HTTPQueryHelper.executePOSTQuery(new URL(parameters.getParameter("location") + "/" + parameters.getParameter("function")), params, username, password);
                parse(inputStream);
                return;
            } catch (ParameterException e) {
            } catch (Exception e) {
                try {
                    System.out.println("Ontodella server at " + parameters.getParameter("location") + "/" + parameters.getParameter("function") + " caused an exception: " + e.getMessage());
                } catch (ParameterException e2) {
                }
            }
            if (locations == null) {
                throw new SAXException("All configured Ontodella servers caused exceptions or no servers configured.");
            }
            for (int i = 0; i < locations.length; i++) {
                try {
                    inputStream = HTTPQueryHelper.executePOSTQuery(new URL(locations[i].getValue() + "/" + parameters.getParameter("function")), params, username, password);
                    parse(inputStream);
                    return;
                } catch (Exception e) {
                    try {
                        System.out.println("Ontodella server at " + locations[i].getValue() + "/" + parameters.getParameter("function") + " caused an exception: " + e.getMessage());
                    } catch (Exception e2) {
                    }
                }
            }
            throw new SAXException("All configured Ontodella servers caused exceptions or no servers configured.");
        }
    }
}

