package seco.fmsweb.generation;
import seco.fmsweb.FMSConfiguration;

import org.apache.excalibur.source.SourceValidity;
import org.apache.excalibur.source.impl.validity.NOPValidity;
import org.apache.excalibur.xml.sax.SAXParser;
import seco.io.StringInputStream;
import org.apache.cocoon.generation.AbstractGenerator;
import org.xml.sax.SAXException;
import org.apache.cocoon.caching.CacheableProcessingComponent;
import org.apache.cocoon.environment.Request;
import org.apache.cocoon.environment.ObjectModelHelper;
import org.apache.cocoon.environment.SourceResolver;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Map;
import org.xml.sax.InputSource;
import org.apache.avalon.framework.parameters.Parameters;
import org.apache.cocoon.ProcessingException;
import org.apache.avalon.framework.component.Component;
import org.apache.avalon.framework.service.Serviceable;
import org.apache.avalon.framework.service.ServiceManager;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
//import org.apache.cocoon.ProcessingException;
//import org.apache.cocoon.environment.ObjectModelHelper;
//import org.apache.cocoon.environment.Request;
//import org.apache.cocoon.environment.SourceResolver;
//import org.xml.sax.helpers.AttributesImpl;

/**
 *  Description of the Class
 *
 *@author     ssaarela
 *@created    6. marraskuuta 2003
 */
public class QueryGenerator extends AbstractGenerator implements Serviceable, CacheableProcessingComponent {
    protected FMSConfiguration cnf = FMSConfiguration.getInstance();
	protected Request request = null;
    protected ServiceManager manager;
    
    public void service(ServiceManager manager) {
        this.manager = manager;
    }
    
	public Serializable getKey() {
			return this.request.getParameter("l")+this.request.getParameter("b")+this.request.getParameter("q");
	}

	public SourceValidity getValidity() {
		return NOPValidity.SHARED_INSTANCE;
	}
    
    public void generate() throws SAXException {
   		String lang = this.request.getParameter("l");
        InputStream in = null;
        if (lang == null) {
            lang = cnf.DEF_RDF_LANG;
        }
   		String base = this.request.getParameter("b");
        if (base == null) {
            base = cnf.BASE;
        }
        String q = this.request.getParameter("q");
        if (q == null) {
            try {
               in = ((org.apache.cocoon.environment.http.HttpRequest)this.request).getInputStream();
            } catch (IOException ioe) {
                ioe.printStackTrace();
            }
        } else {
            in = new StringInputStream(q);
        }
        if (!lang.equals("RDF/XML") && !lang.equals("RDF/XML-ABBREV")) {
            Model model = ModelFactory.createDefaultModel();
            model.read(in, base, lang);
            ByteArrayOutputStream bais = new ByteArrayOutputStream();
            model.write(bais, "RDF/XML");
            model.write(System.out, "N3");
            try {
                in = new StringInputStream(bais.toString("UTF-8"));
            } catch (UnsupportedEncodingException uee) {
                uee.printStackTrace();
            }
            //in = new StringInputStream(bais.toString("ISO-8859-1"));
        }

		SAXParser parser = null;
		try {
			parser = (SAXParser) manager.lookup( SAXParser.ROLE);
		} catch (org.apache.avalon.framework.service.ServiceException se) {
            se.printStackTrace();
		} 
        //catch (org.apache.avalon.framework.component.ComponentException ce) {
        //    ce.printStackTrace();
		//}
	
		try {
			//for (int c = in.read(); c != -1; c = in.read()) {
			//	System.out.print((char)c);
			//}
			parser.parse(new InputSource(in), contentHandler); // This fails.
		} catch (IOException ioe) {
            ioe.printStackTrace();
		} catch (SAXException saxe) {
            saxe.printStackTrace();
		}
		manager.release( (Component)parser );
	}
	public void recycle() {
        super.recycle();
        this.request = null;
    }
	public void setup(SourceResolver resolver, Map objectModel, String src, Parameters par)
             throws ProcessingException, SAXException, IOException {
        super.setup(resolver, objectModel, src, par);
        this.request = ObjectModelHelper.getRequest(objectModel);
    }
}
