<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
    <!ENTITY % fmsentities PUBLIC
   "Museosuomi//ENTITIES Namespaces//EN//XML"
   "fmsentities.pen">
   %fmsentities;
]>
<!--

    File CVS Id: $Id: mobileMuinainen.xslt,v 1.3 2004/03/22 08:44:19 jiemakel Exp $   
    This file is created by the Semantic Computing Research Group as a
    part of the Semantic Web project in 2002-2004 at Helsinki Institute
    for Information Technology (HIIT) and University of Helsinki.

    Group homepage: http://www.cs.helsinki.fi/group/seco/

-->

<xsl:stylesheet version="1.0" xmlns:bm="&bm;" xmlns:fms="&fms;" xmlns:html="&html;" xmlns:java="&java;" xmlns:ogt="&ogt;" xmlns:owl="&owl;" xmlns:rdf="&rdf;" xmlns:rdfs="&rdfs;" xmlns:swhg="&swhg;" xmlns:ui="&ui;" xmlns:uim="&uim;" xmlns:xsd="&xsd;" xmlns:xsl="&xsl;" xmlns:i18n="&i18n;" xmlns:query="&query;">
    <xsl:output doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" encoding="iso-8859-1" indent="yes" media-type="text/xml" method="xml" omit-xml-declaration="no" standalone="yes" version="1.0"/>

	<xsl:include href="xhtmlHelper.xslt" />

	<xsl:template match="rdf:RDF">
		 <html xmlns="http://www.w3.org/1999/xhtml">
            <head>
                <title>
                    <i18n:text>MuseoSuomi</i18n:text>
                </title>
                <meta content="text/html;charset=ISO-8859-1" http-equiv="Content-Type"/>
                <meta content="text/css" http-equiv="Content-Style-Type"/>
                <meta content="Semantic Web" name="description" i18n:attr="content"/>
                <meta content="Semantic web, fmsweb" name="keywords" i18n:attr="content"/>
<!--                <link href="/content/stylesheets/mobile.css" rel="stylesheet" title="FMS-stylesheet basic" type="text/css"/> -->
               <style>
                    body {
                        font-size:medium;
                    }
                    h3,h4 {
                        font-size:large;
                        font-weight:bold;
                    }
                    form
{
	padding:0pt;
	margin:0pt;
	border:0pt;
}
.root
{
    font-weight: bold;
    font-size: medium;
}
                    
.actions
{
    margin-top: 8pt;
    margin-bottom: 5pt;
    text-align:center;
    width:100%;
}
                    
.pagination, .groupBy, .showAll, .remove, .showTree, .action, .more
{
    color: black;
    font-weight: bold;
    font-size: medium;
    text-decoration: none;
    margin: 0pt;
}

.pagination :link, .groupBy :link, .showAll :link, .remove :link, .showTree :link, .action :link, .more :link,
.pagination :visited, .groupBy :visited, .showAll :visited, .remove :visited, .showTree :visited, .action :visited, .more :visited
{
    font-weight: bold;
    font-size: medium;
    color: #048;
    text-decoration: none;
}

.pagination :hover, .groupBy :hover, .showAll :hover, .remove :hover, .showTree :hover, .action :hover
{
    color: #06c;
    text-decoration: underline;
}
.filtered
{
    color: gray;
    font-size:medium;
}
.header 
{
    width: 100%;
    clear: both;
}
.constraintContainer, .constraintContainerProjectionOf, .constraintContainerKeyword, .constraintContainerC0, .constraintContainerC1, .constraintContainerC2, .constraintContainerC3, .constraintContainerC4, .constraintContainerC5, .constraintContainerC6, .constraintContainerC7, .constraintContainerC8
{
    border-width: thin;
    border-color: black;
    border-style: solid;
}

.linkClass
{
    width: 100%;
    font-weight:bold;
    background-color: #abb;
}

.linkPropertyName
{
	font-style: italic;
	clear:both;
}

.itemcategories
{
	margin-top: 1em;
}

.categorylist, .linklist
{
	margin: 0pt;
	border : 0pt;
}

.categorylistitem, .linklistitem
{
	list-style-type : disc;
}

.hits
{
    color: gray;
}

.facet
{
	width:100%;
	font-size: medium;
	margin-bottom:5pt;
}

.itemfacetheader {
    background-color: #abb;
}

.header, .constraint, .itemfacetheader {
	background-color: #abb;
}

.headerKeyword, .constraintKeyword
{
    background-color: #ccaa55;
}

.headerProjectionOf, .constraintProjectionOf
{
    background-color: #aaccaa;
}

.headerC0, .headerC1, .constraintC0, .constraintC1, .itemfacetheaderC0, .itemfacetheaderC1
{
    background-color: #bbaa88;
}

.headerC2, .headerC3, .headerC4, .constraintC2, .constraintC3, .constraintC4, .itemfacetheaderC2, .itemfacetheaderC3, .itemfacetheaderC4
{
    background-color: #bba;
}

.headerC5, .headerC6, .headerC7, .constraintC5, .constraintC6, .constraintC7, .itemfacetheaderC5, .itemfacetheaderC6, .itemfacetheaderC7
{
    background-color: #bbaabb;
}

.headerC8, .constraintC8, .itemfacetheaderC8
{
    background-color: #aabb99;
}


.propertyDefinition
{
	font-weight: bold;
}

.link
{
    min-width: 50%;
    float: left;
}                   
                </style>
             </head>
            <body>
                <xsl:call-template name="mobileSearchHeader"/>
                <h4 id="otsikko" align="center"><xsl:value-of select="/rdf:RDF/rdf:Description[rdf:predicate/@rdf:resource='&muinainen;www_nimi']/rdfs:label" /></h4>
                <a name="kuvat" />
                <xsl:call-template name="navi">
                    <xsl:with-param name="inactive" select="'kuvat'"/>
                </xsl:call-template>
				<div align="center"><xsl:for-each select="ogt:Facet[starts-with(ogt:facetSelector/@rdf:resource,'&query;bookmark')]/ogt:topicOf/bm:Bookmark/fms:www_kuvatiedostonimi">
				                <a href="/gifs/originals{substring-after(text(),'/home/group/seco/public_html/intra/Museo')}">
                                    <img src="/gifs{substring-after(text(),'/home/group/seco/public_html/intra/Museo')}" />
                                </a>
                                <br/>
							</xsl:for-each>
							</div>
                            <a name="tiedot" />
                <xsl:call-template name="navi">
                    <xsl:with-param name="inactive" select="'tiedot'"/>
                </xsl:call-template>
			                <xsl:call-template name="properties" />
                            <a name="kategoriat" />
                <xsl:call-template name="navi">
                    <xsl:with-param name="inactive" select="'kategoriat'"/>
                </xsl:call-template>
			                <xsl:call-template name="categories" />
                            <a name="yhteydet" />
                                            <xsl:call-template name="navi">
                    <xsl:with-param name="inactive" select="'yhteydet'"/>
                </xsl:call-template>
                            
			                <xsl:call-template name="links" />
				<xsl:if test="/rdf:RDF/ui:UState/ui:currentCategory and /rdf:RDF/ui:UState/ui:currentBookmark">
				    <a name="haku"/>
                    <xsl:call-template name="navi">
                        <xsl:with-param name="inactive" select="'haku'"/>
                    </xsl:call-template>
    			    <xsl:call-template name="prevnext" />
                </xsl:if>
                <hr/>
                <span class="action"><a href="&mobilemail;{$ustate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ui:UState/ui:selectedBookmark/@rdf:resource)}&amp;last=muinainen">Lähetä nykyinen sivu ja haku sähköpostilla</a></span>
			                
			</body>
		</html>
	</xsl:template>
	
    <xsl:template name="navi">
        <xsl:param name="inactive" />
        <div class="actions">
            <hr/>
            <xsl:text>[ </xsl:text>
            <xsl:choose>
                <xsl:when test="contains($inactive,'kuvat')">
<!--                   <span class="filtered">kuvat</span> -->
                </xsl:when>
                <xsl:otherwise>
                   <span class="action"><a href="#kuvat">kuvat</a></span>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:choose>
                <xsl:when test="contains($inactive,'tiedot')">
<!--                    <xsl:if test="not(contains($inactive, 'kuvat'))">
                        |
                    </xsl:if>
                   <span class="filtered">tiedot</span> -->
                </xsl:when>
                <xsl:otherwise>
                    <xsl:if test="not(contains($inactive, 'kuvat'))">
                        |
                    </xsl:if>
                    <span class="action"><a href="#tiedot">tiedot</a></span>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:choose>
                <xsl:when test="contains($inactive,'kategoriat')">
<!--                   | <span class="filtered">kategoriat</span> -->
                </xsl:when>
                <xsl:otherwise>
                    | <span class="action"><a href="#kategoriat">kategoriat</a></span>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:choose>
                <xsl:when test="contains($inactive,'yhteydet')">
<!--                    | <span class="filtered">yhteydet</span> -->
                </xsl:when>
                <xsl:otherwise>
                    | <span class="action"><a href="#yhteydet">yhteydet</a></span>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:choose>
                <xsl:when test="contains($inactive,'haku')">
<!--                    | <span class="filtered">haku</span> -->
                </xsl:when>
                <xsl:otherwise>
                    | <span class="action"><a href="#haku">haku</a></span>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:text> ] </xsl:text>
            <hr/>
        </div>
    </xsl:template>
    
  	<xsl:template name="prevnext">
	    <xsl:variable name="cb" select="concat('&amp;cb=',java:net.URLEncoder.encode(/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category),':')"/>
	    <xsl:variable name="cba" select="/rdf:RDF/ui:UState/ui:currentBookmark/@ui:limit"/>
	    <xsl:variable name="cc" select="concat('&amp;cc=',java:net.URLEncoder.encode(/rdf:RDF/ui:UState/ui:currentCategory/@ui:category),':')"/>
	    <xsl:variable name="cca" select="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit"/>
            	    <div align="left" class="pagination">
            	        <xsl:text>(</xsl:text>
            	        <xsl:choose>
            	            <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit=-1">
                                <span class="inactive">&lt;&lt;</span>
                            </xsl:when>
                            <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit &lt; -1 and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category">
                       	        <xsl:text>&lt;&lt; </xsl:text>
                       	        <a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[last()]//bm:Bookmark/@rdf:about)}{$cc}{$cca * -1 - 3}&amp;cb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[last()]/@ogt:catid)}:0"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[last()]/@rdfs:label"/></a>
                       	        <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[last()]/ogt:bookmarkHits"/>)</span>
                            </xsl:when>
                            <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit &lt; -1 and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[last()]//bm:Bookmark">
                       	        <xsl:text>&lt;&lt; </xsl:text>
                       	        <a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category[last()]//bm:Bookmark/@rdf:about)}{$cc}{$cca * -1 - 3}&amp;cb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category[last()]/@ogt:catid)}:0"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category[last()]/ogt:hasRoot/ogt:Category/@rdfs:label"/> &gt; <xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category[last()]/@rdfs:label"/></a>
                       	        <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category[last()]/ogt:bookmarkHits"/>)</span>
                            </xsl:when>
            	            <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit!=0 and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category//bm:Bookmark">
                       	        <xsl:text>&lt;&lt; </xsl:text>
                       	        <a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category//bm:Bookmark/@rdf:about)}{$cc}{$cca - 1}&amp;cb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category/@ogt:catid)}:0"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category/@rdfs:label"/></a>
                       	        <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category/ogt:bookmarkHits"/>)</span>
                       	    </xsl:when>
                       	    <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit!=0 and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category//bm:Bookmark">
                       	        <xsl:text>&lt;&lt; </xsl:text>
                       	        <a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category//bm:Bookmark/@rdf:about)}{$cc}{$cca - 1}&amp;cb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category/@ogt:catid)}:0"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category/ogt:hasRoot/ogt:Category/@rdfs:label"/> &gt; <xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category/@rdfs:label"/></a>
                       	        <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category/ogt:bookmarkHits"/>)</span>
                       	    </xsl:when>
                       	    <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit=0 and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:topicOf/bm:Bookmark and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category">
                       	        <xsl:text>&lt;&lt; </xsl:text>
                       	        <a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:topicOf/bm:Bookmark/@rdf:about)}{$cc}-1&amp;cb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/@ogt:catid)}:0"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/@rdfs:label"/></a>
                       	        <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:directBookmarkHits"/>)</span>
                  	        </xsl:when>
                       	    <xsl:otherwise>
                                <span class="inactive">&lt;&lt;</span>
                  	        </xsl:otherwise>
                       	</xsl:choose>
                        <xsl:text>)</xsl:text>
                	</div>
                     <div class="pagination" align="left">
                        <xsl:text>(</xsl:text>
                        <xsl:choose>
                            <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit=-1 and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category">
                                   <xsl:text>&gt;&gt; </xsl:text><a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category//bm:Bookmark/@rdf:about)}{$cc}0&amp;cb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category/@ogt:catid)}:0"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category/@rdfs:label"/></a>
                                   <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category/ogt:bookmarkHits"/>)</span>
                            </xsl:when>
                            <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit=0 and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[2] and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category">
                                <xsl:text>&gt;&gt; </xsl:text>
                                <a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[2]/ogt:topicOf/bm:Bookmark/@rdf:about)}{$cc}{$cca + 1}&amp;cb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[2]/@ogt:catid)}:0"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[2]/@rdfs:label"/></a>
                                <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[2]/ogt:bookmarkHits"/>)</span>
                            </xsl:when>
                               <xsl:when test="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[3] and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category">
                                 <xsl:text>&gt;&gt; </xsl:text>
                                 <a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[3]/ogt:topicOf/bm:Bookmark/@rdf:about)}{$cc}{$cca + 1}&amp;cb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[3]/@ogt:catid)}:0"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[3]/@rdfs:label"/></a>
                                 <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category[3]/ogt:bookmarkHits"/>)</span>
                               </xsl:when>
                               <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit=0 and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[2]">
                                   <xsl:text>&gt;&gt; </xsl:text>
                                   <a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[2]/ogt:topicOf/bm:Bookmark/@rdf:about)}{$cc}{$cca + 1}&amp;cb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[2]/@ogt:catid)}:0"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[2]/ogt:hasRoot/ogt:Category/@rdfs:label"/> &gt; <xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[2]/@rdfs:label"/></a>
                                   <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[2]/ogt:bookmarkHits"/>)</span>
                               </xsl:when>
                               <xsl:when test="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[3]">
                                   <xsl:text>&gt;&gt; </xsl:text>
                                   <a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[3]/ogt:topicOf/bm:Bookmark/@rdf:about)}{$cc}{$cca + 1}&amp;cb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[3]/@ogt:catid)}:0"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[3]/ogt:hasRoot/ogt:Category/@rdfs:label"/> &gt; <xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[3]/@rdfs:label"/></a>
                                   <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[3]/ogt:bookmarkHits"/>)</span>
                               </xsl:when>
                               <xsl:when test="not(/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit &lt; -1) and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:topicOf/bm:Bookmark">
                                   <xsl:text>&gt;&gt; </xsl:text><a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:topicOf/bm:Bookmark/@rdf:about)}{$cc}{-1 * $cca - 3}&amp;cb=:0">Muita kohteita</a>
                                   <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:remainder"/>)</span>
                               </xsl:when>
                            <xsl:otherwise>
                                <span class="inactive">&gt;&gt;</span>
                            </xsl:otherwise>
                          </xsl:choose>
                          <xsl:text>)</xsl:text>
                      </div>
                      <div align="left" class="pagination">
                          <xsl:choose>
                              <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:category='' and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/@rdfs:label">
                                  <xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:hasRoot/ogt:Category/@rdfs:label"/>
                                  &gt;
                                  <xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/@rdfs:label"/>
                                  <span class="hits">
                                      <xsl:text> (</xsl:text>
                                      <xsl:choose>
                                          <xsl:when test="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:directBookmarkHits">
                                             <xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:directBookmarkHits"/>
                                          </xsl:when>
                                          <xsl:otherwise>
                                             <xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:bookmarkHits"/>
                                          </xsl:otherwise>    
                                      </xsl:choose>
                                      <xsl:text>)</xsl:text>
                                  </span>
                              </xsl:when>
                              <xsl:when test="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/@rdfs:label">
                                  <xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/@rdfs:label"/>
                                  <span class="hits">
                                      <xsl:text> (</xsl:text>
                                      <xsl:choose>
                                          <xsl:when test="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:directBookmarkHits">
                                             <xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:directBookmarkHits"/>
                                          </xsl:when>
                                          <xsl:otherwise>
                                             <xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:bookmarkHits"/>
                                          </xsl:otherwise>    
                                      </xsl:choose>
                                      <xsl:text>)</xsl:text>
                                  </span>
                              </xsl:when>
                              <xsl:when test="not(/rdf:RDF/ui:UState/ui:groupBy)">
                                  Kohteet
                                  <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:remainder"/>)</span>
                              </xsl:when>
                              <xsl:otherwise>
                                  Muita kohteita
                                  <span class="hits"> (<xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:remainder"/>)</span>
                              </xsl:otherwise>
                          </xsl:choose>                          
                      </div>
                      <div align="left" class="pagination">
                        <xsl:text>(</xsl:text>
                        <xsl:choose>
                	        <xsl:when test="/rdf:RDF/ui:UState/ui:currentBookmark/@ui:limit=0">
                    	        <span class="inactive">&lt;</span>
                	        </xsl:when>
                            <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit &lt; -1">
                                <xsl:text>&lt; </xsl:text><a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:topicOf/bm:Bookmark[1]/@rdf:about)}{$cc}{$cca}{$cb}{$cba - 1}"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:topicOf/bm:Bookmark[1]/@rdfs:label"/></a>
                            </xsl:when>
                      	    <xsl:otherwise>
                                <xsl:text>&lt; </xsl:text><a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:topicOf/bm:Bookmark[1]/@rdf:about)}{$cc}{$cca}{$cb}{$cba - 1}"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:topicOf/bm:Bookmark[1]/@rdfs:label"/></a>
                            </xsl:otherwise>
                	    </xsl:choose>
                	    <xsl:text>)</xsl:text>
                	    </div>
                      <div align="left" class="pagination">
                         <xsl:text>(</xsl:text>
                       <xsl:choose>
                             <xsl:when test="/rdf:RDF/ui:UState/ui:currentBookmark/@ui:limit=0 and (/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:topicOf/bm:Bookmark[2])">
                               <xsl:text>&gt; </xsl:text><a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:topicOf/bm:Bookmark[2]/@rdf:about)}{$cc}{$cca}{$cb}{$cba + 1}"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:topicOf/bm:Bookmark[2]/@rdfs:label"/></a>
                             </xsl:when>
                             <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit &lt; -1 and /rdf:RDF/ui:UState/ui:currentBookmark/@ui:limit=0 and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:topicOf/bm:Bookmark[2]">
                               <xsl:text>&gt; </xsl:text><a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:topicOf/bm:Bookmark[2]/@rdf:about)}{$cc}{$cca}{$cb}{$cba + 1}"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:topicOf/bm:Bookmark[2]/@rdfs:label"/></a>
                            </xsl:when>
                             <xsl:when test="/rdf:RDF/ui:UState/ui:currentCategory/@ui:limit &lt; -1 and /rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:topicOf/bm:Bookmark[3]">
                               <xsl:text>&gt; </xsl:text><a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:topicOf/bm:Bookmark[3]/@rdf:about)}{$cc}{$cca}{$cb}{$cba + 1}"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']/ogt:topicOf/bm:Bookmark[3]/@rdfs:label"/></a>
                            </xsl:when>
                             <xsl:when test="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:topicOf/bm:Bookmark[3]">
                               <xsl:text>&gt; </xsl:text><a href="&item;{$ustate}{$gBy}&amp;sb={java:net.URLEncoder.encode(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:topicOf/bm:Bookmark[3]/@rdf:about)}{$cc}{$cca}{$cb}{$cba + 1}"><xsl:value-of select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;prevNext']//ogt:Category[@ogt:catid=/rdf:RDF/ui:UState/ui:currentBookmark/@ui:category]/ogt:topicOf/bm:Bookmark[3]/@rdfs:label"/></a>
                             </xsl:when>
                             <xsl:otherwise>
                                 <span class="inactive">&gt;</span>
                             </xsl:otherwise>
                          </xsl:choose>
                          <xsl:text>)</xsl:text>                          
                      </div>
    </xsl:template>
	
	<xsl:template name="properties">
	    <xsl:if test="/rdf:RDF/rdf:Description[rdf:predicate/@rdf:resource='&muinainen;www_paikka']/rdfs:label">
    	    <div class="property"><span class="propertyDefinition"><i18n:text>Paikka</i18n:text>: </span><span class="properyValue"><xsl:value-of select="/rdf:RDF/rdf:Description[rdf:predicate/@rdf:resource='&muinainen;www_paikka']/rdfs:label" /></span></div>	
        </xsl:if>   	    
	    <xsl:if test="/rdf:RDF/rdf:Description[rdf:predicate/@rdf:resource='&muinainen;www_valmistusaika']/rdfs:label">
    	    <div class="property"><span class="propertyDefinition"><i18n:text>Aika</i18n:text>: </span><span class="properyValue"><xsl:value-of select="/rdf:RDF/rdf:Description[rdf:predicate/@rdf:resource='&muinainen;www_valmistusaika']/rdfs:label" /></span></div>	
        </xsl:if>   	    
	    <xsl:if test="/rdf:RDF/rdf:Description[rdf:predicate/@rdf:resource='&muinainen;www_kohde']/rdfs:label">
    	    <div class="property"><span class="propertyDefinition"><i18n:text>Kohde</i18n:text>: </span><span class="properyValue"><xsl:value-of select="/rdf:RDF/rdf:Description[rdf:predicate/@rdf:resource='&muinainen;www_kohde']/rdfs:label" /></span></div>	
        </xsl:if>
	    <xsl:if test="/rdf:RDF/rdf:Description[rdf:predicate/@rdf:resource='&muinainen;www_tunnus']/rdfs:label">
    	    <div class="property"><span class="propertyDefinition"><i18n:text>ID</i18n:text>: </span><span class="properyValue"><xsl:value-of select="/rdf:RDF/rdf:Description[rdf:predicate/@rdf:resource='&muinainen;www_tunnus']/rdfs:label" /></span></div>	
        </xsl:if>   	    
	    <xsl:if test="/rdf:RDF/rdf:Description[rdf:predicate/@rdf:resource='&muinainen;www_kuvaus']/rdfs:label">
    		<div class="description"><xsl:value-of select="/rdf:RDF/rdf:Description[rdf:predicate/@rdf:resource='&muinainen;www_kuvaus']/rdfs:label" /></div>
        </xsl:if>   	    
	</xsl:template>
		
	<xsl:template name="categories">
	    <div class="itemcategories">
    	    <xsl:apply-templates mode="root" select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories"/>
	    </div>
    </xsl:template>
    
    <xsl:template match="ogt:Category" mode="root">
        <xsl:variable name="catid" select="@ogt:catid"/>
        <xsl:if test="/rdf:RDF/ogt:Facet/ogt:topicOf/bm:Bookmark/bm:hasTopic/ogt:Category[ogt:hasRoot/ogt:Category/@ogt:catid=$catid]">
            <div class="facet">
	            <div class="itemfacetheaderC{descendant-or-self::fms:rootcatid}">
                    <div class="root"><xsl:value-of select="@rdfs:label"/>:</div>
                    <ul class="categorylist">
    					<xsl:apply-templates mode="category" select="/rdf:RDF/ogt:Facet/ogt:topicOf/bm:Bookmark/bm:hasTopic/ogt:Category[ogt:hasRoot/ogt:Category/@ogt:catid=$catid]"/>
                	</ul>
                </div>
            </div>
        </xsl:if>            
    </xsl:template>

    <xsl:template match="ogt:Category" mode="category">
        <li class="categorylistitem">
            <xsl:apply-templates mode="path" select="ogt:hasRoot/ogt:Category/ogt:subCategories/ogt:Category">
                <xsl:with-param name="isFirst">true</xsl:with-param>
            </xsl:apply-templates>
                <xsl:if test="ogt:hasRoot/ogt:Category/ogt:subCategories/ogt:Category">
                    &gt;
                </xsl:if>
				<a href="&main;{$prefs}&amp;n={java:net.URLEncoder.encode(@ogt:catid)}&amp;g=c{java:net.URLEncoder.encode(@ogt:catid)}">
					<xsl:value-of select="@rdfs:label"/>
				</a>
                <span class="hits">
                    <xsl:text> (</xsl:text><xsl:value-of select="ogt:bookmarkHits"/><xsl:text>)</xsl:text>
                </span>
        </li>
    </xsl:template>
        
        <!-- Path with every category selectable -->
    <xsl:template match="ogt:Category" mode="path">
        <xsl:param name="isFirst"/>
            <xsl:if test="not($isFirst)">
                &gt;
            </xsl:if>
            <a href="&main;{$prefs}&amp;n={java:net.URLEncoder.encode(@ogt:catid)}&amp;g=c{java:net.URLEncoder.encode(@ogt:catid)}">
                <xsl:value-of select="@rdfs:label"/>
            </a>
            <span class="hits">
                <xsl:text> (</xsl:text><xsl:value-of select="ogt:bookmarkHits"/><xsl:text>)</xsl:text>
            </span>
		<xsl:apply-templates mode="path" select="ogt:subCategories"/>
    </xsl:template>

	<xsl:template name="links">
		<xsl:for-each select="/rdf:RDF/rdf:Description/swhg:relations/swhg:RelationGroup">
			<div class="links">
				<div class="linkClass"><xsl:value-of select="rdfs:label"/></div>
				<xsl:call-template name="linkProperty" />
			</div>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="linkProperty">
		<xsl:for-each select="swhg:relations/swhg:RelationGroup[swhg:relations/swhg:relation]">
			<div class="linkProperty">
					<div class="linkPropertyName"><xsl:value-of select="rdfs:label" />: </div>
					<ul class="linklist">
					    <xsl:apply-templates select="swhg:relations/swhg:relation[position()&lt;6]"/>
					</ul>
			</div>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template match="swhg:relation">
	    <li><a href="&mobileitem;{$ustate}{$groupBy}{$csstate}&amp;sb={java:net.URLEncoder.encode(@swhg:target)}"><xsl:value-of select="rdfs:label" /></a></li>
    </xsl:template>

</xsl:stylesheet>