<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
    <!ENTITY % fmsentities PUBLIC
   "Museosuomi//ENTITIES Namespaces//EN//XML"
   "fmsentities.pen">
   %fmsentities;
]><!--

    File CVS Id: $Id: ogtPreQuery.xslt,v 1.1.1.1 2004/01/26 12:42:09 jiemakel Exp $   
	This file is created by the Semantic Computing Research Group as a
	part of the Semantic Web project in 2002-2004 at Helsinki Institute
	for Information Technology (HIIT) and University of Helsinki.

	Group homepage: http://www.cs.helsinki.fi/group/seco/

	Short description of this file:
	XSLT-stylesheet to transform user state and roots into query to Ontogator.

        Change history (mailto: samppa.saarela@cs.helsinki.fi):

	10.11.2003 ssaarela  finished first draft version 0.1 of this file.
        only category hierarchy implemented
-->
<xsl:stylesheet version="1.0" xmlns:bm="&bm;" xmlns:fms="&fms;" xmlns:ogt="&ogt;" xmlns:rdf="&rdf;" xmlns:rdfs="&rdfs;" xmlns:ui="&ui;" xmlns:xsd="http://www.w3.org/2000/10/XMLSchema#" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<!--
	<xsl:output doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" encoding="iso-8859-1" indent="yes" media-type="text/xml" method="xml" omit-xml-declaration="no" standalone="yes" version="1.0"/>
-->
    <xsl:template match="/rdf:RDF/ui:UState">
        <rdf:RDF xmlns="&ogt;" xmlns:bm="&bm;" xmlns:ogt="&ogt;" xmlns:rdf="&rdf;" xmlns:fms="&fms;" xmlns:rdfs="&rdfs;">
            <xsl:if test="ui:showBookmarks = 'true'">
                <xsl:for-each select="ui:category[@ui:selected = 'true']">
                    <xsl:call-template name="category"/>
                </xsl:for-each>
                <xsl:for-each select="ui:projectedFrom">
                    <xsl:call-template name="projectedFrom"/>
                </xsl:for-each>
                <xsl:for-each select="ui:keyword">
                    <xsl:call-template name="keyword"/>
                </xsl:for-each>
                <xsl:call-template name="hits"/>
            </xsl:if>
        </rdf:RDF>
    </xsl:template>

    <xsl:variable name="language" select="/rdf:RDF/ui:UState/ui:language"/>
	
    <xsl:variable name="constraint">
        <xsl:for-each select="/rdf:RDF/ui:UState/ui:category[@ui:selected = 'true']">
            <rdf:Description rdf:about="&query;c{@ui:catid}"/>
        </xsl:for-each>
        <xsl:for-each select="/rdf:RDF/ui:UState/ui:keyword">
            <rdf:Description rdf:about="&query;k{text()}"/>
        </xsl:for-each>
        <xsl:for-each select="/rdf:RDF/ui:UState/ui:projectedFrom">
            <rdf:Description rdf:about="&query;p{@rdf:resource}"/>
        </xsl:for-each>
    </xsl:variable>

    <xsl:template name="hits">
        <xsl:variable name="bmOptions">
            <ogt:incBookmarks>false</ogt:incBookmarks>
            <ogt:incBookmarkHits>false</ogt:incBookmarkHits>
            <ogt:incRemainder>true</ogt:incRemainder>
            <ogt:incDirectBookmarkHits>true</ogt:incDirectBookmarkHits>
            <ogt:incTopics>NONE</ogt:incTopics>
            <ogt:maxBookmarks ogt:limit="0"/>
<!--            <ogt:acceptLanguage>
                <xsl:value-of select="ui:language"/>
            </ogt:acceptLanguage> -->
<!--            <ogt:incBookmarkProperty rdf:resource="&fms;www_kuvatiedostonimi"/> -->
            <xsl:if test="$constraint">
                <ogt:constraint rdf:parseType="Collection">
                    <xsl:copy-of select="$constraint"/>
                </ogt:constraint>
            </xsl:if>
        </xsl:variable>
        <xsl:variable name="categoryOptions">
            <ogt:filter>POST-QUERY</ogt:filter>
            <ogt:incPath>false</ogt:incPath>
            <ogt:incSubCategoryHits>true</ogt:incSubCategoryHits>
            <xsl:copy-of select="$bmOptions"/>
        </xsl:variable>
        <xsl:choose>
			<!-- Bookmarks grouped by category -->
            <xsl:when test="ui:groupBy/@ui:catid">
                <ogt:FacetSelector rdf:about="&query;hits">
                    <ogt:incCategories>true</ogt:incCategories>
                    <ogt:incSubCategories>DIRECT</ogt:incSubCategories>
					<ogt:maxSubCategories ogt:onCategory="{ui:groupBy/@ui:catid}" ogt:limit="0"/>
                    <ogt:category>
                        <xsl:value-of select="ui:groupBy/@ui:catid"/>
                    </ogt:category>
                    <xsl:copy-of select="$categoryOptions"/>
                </ogt:FacetSelector>
            </xsl:when>
			<!-- Bookmarks grouped by keyword -->
            <xsl:when test="ui:groupBy/@ui:keyword">
                <ogt:FacetSelector rdf:about="&query;hits">
                    <ogt:incCategories>false</ogt:incCategories>
                    <rdfs:label>
                        <xsl:value-of select="ui:groupBy/@ui:keyword"/>
                    </rdfs:label>
                    <ogt:categoryKeyword>
                        <xsl:value-of select="ui:groupBy/@ui:keyword"/>
                    </ogt:categoryKeyword>
                    <ogt:bookmarkKeyword>
                        <xsl:value-of select="ui:groupBy/@ui:keyword"/>
                    </ogt:bookmarkKeyword>
                    <ogt:incSubCategories>NONE</ogt:incSubCategories>
                    <xsl:copy-of select="$categoryOptions"/>
                </ogt:FacetSelector>
            </xsl:when>
			<!-- Bookmarks ungrouped -->
<!--            <xsl:otherwise>
                <ogt:FacetSelector rdf:about="&query;hits">
                    <ogt:incCategories>false</ogt:incCategories>
                    <xsl:copy-of select="$bmOptions"/>
                </ogt:FacetSelector>
            </xsl:otherwise>-->
        </xsl:choose>
    </xsl:template>
	
    <xsl:template name="category">
        <ogt:FacetSelector rdf:about="&query;c{@ui:catid}" 
                ogt:incPath="false" 
                ogt:incBookmarks="false" 
                ogt:incCategories="false" 
                ogt:incSubCategories="NONE" 
                ogt:incTopics="NONE"
                ogt:incBookmarkHits="false"
				ogt:incSubCategoryHits="false">
            <ogt:category>
                <xsl:value-of select="@ui:catid"/>
            </ogt:category>
        </ogt:FacetSelector>
    </xsl:template>
	
    <xsl:template name="projectedFrom">
        <ogt:FacetSelector rdf:about="&query;p{@rdf:resource}" 
                ogt:incPath="false" 
                ogt:incBookmarks="false" 
                ogt:incCategories="false" 
                ogt:incSubCategories="NONE" 
                ogt:incTopics="NONE"
                ogt:incBookmarkHits="false"
				ogt:incSubCategoryHits="false">
            <ogt:projectedFrom>
                <xsl:attribute name="rdf:resource" namespace="&rdf;">
                    <xsl:value-of select="@rdf:resource"/>
                </xsl:attribute>
            </ogt:projectedFrom>
        </ogt:FacetSelector>
    </xsl:template>
	
    <xsl:template name="keyword">
        <ogt:FacetSelector rdf:about="&query;k{text()}" 
                ogt:incPath="false" 
                ogt:incBookmarks="false" 
                ogt:incCategories="false" 
                ogt:incSubCategories="NONE"
                ogt:incBookmarkHits="false"
				ogt:incSubCategoryHits="false">
            <ogt:categoryKeyword>
                <xsl:value-of select="text()"/>
            </ogt:categoryKeyword>
            <ogt:bookmarkKeyword>
                <xsl:value-of select="text()"/>
            </ogt:bookmarkKeyword>
        </ogt:FacetSelector>
    </xsl:template>
</xsl:stylesheet>
