<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
    <!ENTITY % fmsentities PUBLIC
   "Museosuomi//ENTITIES Namespaces//EN//XML"
   "fmsentities.pen">
   %fmsentities;
]><!--

    File CVS Id: $Id: ogtTreeQuery.xslt,v 1.3 2004/03/19 12:37:03 jiemakel Exp $   
	This file is created by the Semantic Computing Research Group as a
	part of the Semantic Web project in 2002-2004 at Helsinki Institute
	for Information Technology (HIIT) and University of Helsinki.

	Group homepage: http://www.cs.helsinki.fi/group/seco/

	Short description of this file:
	XSLT-stylesheet to transform user state and roots into query to Ontogator.

        Change history (mailto: samppa.saarela@cs.helsinki.fi):

	10.11.2003 ssaarela  finished first draft version 0.1 of this file.
        only category hierarchy implemented
-->
<xsl:stylesheet version="1.0" xmlns:bm="&bm;" xmlns:fms="&fms;" xmlns:ogt="&ogt;" xmlns:rdf="&rdf;" xmlns:rdfs="&rdfs;" xmlns:ui="&ui;" xmlns:xsd="http://www.w3.org/2000/10/XMLSchema#" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<!--
	<xsl:output doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" encoding="iso-8859-1" indent="yes" media-type="text/xml" method="xml" omit-xml-declaration="no" standalone="yes" version="1.0"/>
-->
    <xsl:param name="category" select="/rdf:RDF/ui:UState/ui:showTree/@ui:catid" />
    
    <xsl:include href="ogtHelper.xslt"/>
    
	<xsl:template match="rdf:RDF">
		<rdf:RDF xmlns="&ogt;" xmlns:bm="&bm;" xmlns:ogt="&ogt;" xmlns:rdf="&rdf;" xmlns:fms="&fms;" xmlns:rdfs="&rdfs;">
		    <xsl:for-each select="ui:UState/ui:category[@ui:selected = 'true']">
                <xsl:call-template name="constraints"/>
            </xsl:for-each>
            <xsl:for-each select="ui:UState/ui:projectedFrom">
                <xsl:call-template name="projectedFrom"/>
            </xsl:for-each>
            <xsl:for-each select="ui:UState/ui:keyword">
                <xsl:call-template name="keyword"/>
            </xsl:for-each>
            <xsl:if test="ui:UState/ui:coordinates">
            	<xsl:call-template name="coordinates"/>
            </xsl:if>
		    
			<ogt:FacetSelector rdf:about="&query;c{$category}" 
                    ogt:incPath="true" 
                    ogt:filter="{/rdf:RDF/ui:UState/ui:filter}" 
                    ogt:acceptLanguage="{/rdf:RDF/ui:UState/ui:language}" 
                    ogt:incBookmarks="false"
                    ogt:incSubCategories="ALL">
				<ogt:category>
					<xsl:value-of select="$category"/>
				</ogt:category>
            	<ogt:incCategoryProperty rdf:resource="&fms;rootcatid"/>
				<xsl:if test="$constraint">
					<ogt:constraint rdf:parseType="Collection">
						<xsl:copy-of select="$constraint"/>						
					</ogt:constraint>
				</xsl:if>
			</ogt:FacetSelector>
		</rdf:RDF>
	</xsl:template>
	
</xsl:stylesheet>
