<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
    <!ENTITY % fmsentities PUBLIC
   "Museosuomi//ENTITIES Namespaces//EN//XML"
   "fmsentities.pen">
   %fmsentities;
]><!--

    File CVS Id: $Id: ustate.xslt,v 1.6 2004/03/19 11:06:23 jiemakel Exp $   
	This file is created by the Semantic Computing Research Group as a
	part of the Semantic Web project in 2002-2004 at Helsinki Institute
	for Information Technology (HIIT) and University of Helsinki.

	Group homepage: http://www.cs.helsinki.fi/group/seco/

	Short description of this file:
	XSLT-stylesheet to transform user state and roots into query to Ontogator.

        Change history (mailto: samppa.saarela@cs.helsinki.fi):

	10.11.2003 ssaarela  finished first draft version 0.1 of this file.
        only category hierarchy implemented
-->
<xsl:stylesheet version="1.0" xmlns:bm="&bm;" xmlns:fms="&fms;" xmlns:swhg="&swhg;" xmlns:ogt="&ogt;" xmlns:rdf="&rdf;" xmlns:rdfs="&rdfs;" xmlns:ui="&ui;" xmlns:xsd="http://www.w3.org/2000/10/XMLSchema#" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:owl="&owl;">

<!--	<xsl:output encoding="UTF-8" indent="yes" media-type="text/xml" method="xml" omit-xml-declaration="no" standalone="yes" version="1.0"/> -->
	<xsl:template match="rdf:RDF">
		<rdf:RDF xmlns="&ogt;" xmlns:bm="&bm;" xmlns:ogt="&ogt;" xmlns:rdf="&rdf;" xmlns:fms="&fms;" xmlns:rdfs="&rdfs;" xmlns:ui="&ui;">
			<ui:UState>
                <xsl:if test="ogt:CategoryBase/owl:versionInfo">
                    <ui:categoryBase><xsl:value-of select="ogt:CategoryBase/owl:versionInfo"/></ui:categoryBase>
                </xsl:if>
				<xsl:apply-templates select="ogt:Facet[ogt:facetSelector/@rdf:resource = '&query;roots']/ogt:subCategories/*"/>
                <xsl:apply-templates select="ui:UState/*"/>
                <xsl:apply-templates select="/rdf:RDF/swhg:NearestLocation"/>
                <xsl:apply-templates select="/rdf:RDF/swhg:NearestMuinainen"/>
                <ui:maxBookmarks>
                    <xsl:choose>
                         <xsl:when test="ui:UState/ui:mobile/text()='true'">
                             <xsl:text>4</xsl:text>
                         </xsl:when>
                         <xsl:when test="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;hits']/ogt:subCategories/ogt:Category/ogt:subCategoryHits &lt; 4">
                             <xsl:value-of select="(4-ogt:Facet[ogt:facetSelector/@rdf:resource='&query;hits']/ogt:subCategories/ogt:Category/ogt:subCategoryHits)*4"/>
                         </xsl:when>
                         <xsl:otherwise><xsl:text>4</xsl:text></xsl:otherwise>
                     </xsl:choose>
                </ui:maxBookmarks>
                <ui:maxGroups>
                    <xsl:choose>
                         <xsl:when test="ui:UState/ui:mobile/text()='true'">
                             <xsl:choose>
                                 <xsl:when test="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;hits']/ogt:subCategories/ogt:Category/ogt:directBookmarkHits!=0 and not(/rdf:RDF/ui:UState/ui:skipCategories)">
                                     <xsl:text>3</xsl:text>
                                 </xsl:when>
                                 <xsl:otherwise>
                                     <xsl:text>4</xsl:text>
                                 </xsl:otherwise>
                             </xsl:choose>
                         </xsl:when>
                         <xsl:otherwise>
                             <xsl:choose>
                                 <xsl:when test="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;hits']/ogt:subCategories/ogt:Category/ogt:directBookmarkHits!=0 and not(/rdf:RDF/ui:UState/ui:skipCategories)">
                                     <xsl:text>7</xsl:text>
                                 </xsl:when>
                                 <xsl:otherwise>
                                     <xsl:text>8</xsl:text>
                                 </xsl:otherwise>
                             </xsl:choose>
                         </xsl:otherwise>
                    </xsl:choose>
                </ui:maxGroups>
                <xsl:choose>
                    <xsl:when test="ui:UState/ui:newSkipBookmarks[@ui:category=''] and ui:UState/ui:newSkipBookmarks[@ui:category='']/@ui:limit != 0">
                        <ui:skipBookmarks>
          		        <xsl:attribute name="ui:limit">
    	    		        <xsl:value-of select="ui:UState/ui:newSkipBookmarks[@ui:category='']/@ui:limit"/>
      		            </xsl:attribute>
                        </ui:skipBookmarks>
                    </xsl:when>
                    <xsl:when test="ui:UState/ui:skipBookmarks[not(@ui:category)] and ui:UState/ui:skipBookmarks[@ui:category='']/@ui:limit != 0">
                        <ui:skipBookmarks>
          		        <xsl:attribute name="ui:limit">
    	    		        <xsl:value-of select="ui:UState/ui:skipBookmarks[@ui:category='']/@ui:limit"/>
      		            </xsl:attribute>
                        </ui:skipBookmarks>
                    </xsl:when>
                </xsl:choose>
<!--                <xsl:choose>
                    <xsl:when test="ui:UState/ui:newSkipCategories[@ui:category=''] and ui:UState/ui:newSkipCategories[@ui:category='']/@ui:limit != 0">
                        <ui:skipCategories>
          		        <xsl:attribute name="ui:limit">
    	    		        <xsl:value-of select="ui:UState/ui:newSkipCategories[@ui:category='']/@ui:limit"/>
      		            </xsl:attribute>
                        </ui:skipCategories>
                    </xsl:when>
                    <xsl:when test="ui:UState/ui:skipCategories[not(@ui:category)] and ui:UState/ui:skipCategories[@ui:category='']/@ui:limit != 0">
                        <ui:skipCategories>
          		        <xsl:attribute name="ui:limit">
    	    		        <xsl:value-of select="ui:UState/ui:skipCategories[@ui:category='']/@ui:limit"/>
      		            </xsl:attribute>
                        </ui:skipCategories>
                    </xsl:when>
                </xsl:choose> -->
			</ui:UState>
		</rdf:RDF>
	</xsl:template>
    <xsl:template match="@*|node()">
        <xsl:copy-of select="."/>
    </xsl:template>
	<xsl:template match="ogt:Category">
			<xsl:variable name="catid" select="@ogt:catid"/>
			<xsl:variable name="newCategory" select="/rdf:RDF/ui:UState/ui:newCategory[starts-with(@ui:catid, $catid)]"/>
			<xsl:variable name="category" select="/rdf:RDF/ui:UState/ui:category[starts-with(@ui:catid, $catid)]"/>
		<ui:category>
			<xsl:choose>
				<xsl:when test="$newCategory">
					<xsl:attribute name="ui:selected" namespace="&ui;">true</xsl:attribute>
                    <xsl:attribute name="ui:catid" namespace="&ui;">
    					<xsl:value-of select="$newCategory/@ui:catid"/>
                    </xsl:attribute>
				</xsl:when>
				<xsl:when test="$category">
					<xsl:attribute name="ui:selected" namespace="&ui;">true</xsl:attribute>
                    <xsl:attribute name="ui:catid" namespace="&ui;">
                        <xsl:value-of select="$category/@ui:catid"/>
                    </xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
                    <xsl:attribute name="ui:catid" namespace="&ui;">
                        <xsl:value-of select="$catid"/>
                    </xsl:attribute>
                </xsl:otherwise>
			</xsl:choose>
		</ui:category>
	</xsl:template>
    <xsl:template match="ui:UState/ui:category"/>
    <xsl:template match="ui:UState/ui:newSkipBookmarks">
        <xsl:if  test="@ui:limit != 0 and not(@ui:category='')">
            		<ui:skipBookmarks>
    	    		    <xsl:attribute name="ui:category">
    	    		        <xsl:value-of select="@ui:category"/>
           		        </xsl:attribute>
          		        <xsl:attribute name="ui:limit">
    	    		        <xsl:value-of select="@ui:limit"/>
      		            </xsl:attribute>
               	    </ui:skipBookmarks>
        </xsl:if>
    </xsl:template>
    <xsl:template match="ui:UState/ui:skipBookmarks">
        <xsl:variable name="catid" select="@ui:category"/>
		<xsl:variable name="newSkipBookmarks" select="/rdf:RDF/ui:UState/ui:newSkipBookmarks[@ui:category=$catid]"/>
        <xsl:if  test="@ui:limit != 0 and not($newSkipBookmarks) and not(@ui:category='')">
            		<ui:skipBookmarks>
    	    		    <xsl:attribute name="ui:category">
    	    		        <xsl:value-of select="@ui:category"/>
           		        </xsl:attribute>
          		        <xsl:attribute name="ui:limit">
    	    		        <xsl:value-of select="@ui:limit"/>
      		            </xsl:attribute>
               	    </ui:skipBookmarks>
        </xsl:if>    
    </xsl:template>
    
    <xsl:template match="swhg:NearestLocation">
<!--    	<xsl:if test="not(/rdf:RDF/ui:UState/ui:projectedFrom)">
	    	<ui:projectedFrom rdf:resource="{swhg:nearest/swhg:location/@rdf:resource}"/>
	    	<ui:groupBy ui:projectedFrom="{swhg:nearest/swhg:location/@rdf:resource}"/>
    	</xsl:if> -->
    	<xsl:copy-of select="."/>
    </xsl:template>
    
<!--    <xsl:template match="ui:UState/ui:newSkipCategories">
                        <xsl:if  test="@ui:limit != 0">
            		<ui:skipCategories>
    	    		    <xsl:attribute name="ui:category">
    	    		        <xsl:value-of select="@ui:category"/>
           		        </xsl:attribute>
          		        <xsl:attribute name="ui:limit">
    	    		        <xsl:value-of select="@ui:limit"/>
      		            </xsl:attribute>
               	    </ui:skipCategories>
          	    </xsl:if>
    </xsl:template> -->
<!--    <xsl:template match="ui:UState/ui:skipCategories">
        <xsl:variable name="catid" select="@ui:category"/>
		<xsl:variable name="newSkipCategories" select="/rdf:RDF/ui:UState/ui:newSkipCategories[starts-with(@ui:category, $catid) or starts-with($catid,@ui:category)]"/>
        <xsl:choose>
            <xsl:when test="not($newSkipCategories)">
                <xsl:if  test="@ui:limit != 0">
            		<ui:skipCategories>
    	    		    <xsl:attribute name="ui:category">
    	    		        <xsl:value-of select="@ui:category"/>
           		        </xsl:attribute>
          		        <xsl:attribute name="ui:limit">
    	    		        <xsl:value-of select="@ui:limit"/>
      		            </xsl:attribute>
               	    </ui:skipCategories>
          	    </xsl:if>    
             </xsl:when>
          </xsl:choose>
    </xsl:template> -->
</xsl:stylesheet>
