<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
    <!ENTITY % fmsentities PUBLIC
   "Museosuomi//ENTITIES Namespaces//EN//XML"
   "fmsentities.pen">
   %fmsentities;
]>
<!--

    File CVS Id: $Id: webItems.xslt,v 1.4 2004/03/22 08:44:19 jiemakel Exp $   
    This file is created by the Semantic Computing Research Group as a
    part of the Semantic Web project in 2002-2004 at Helsinki Institute
    for Information Technology (HIIT) and University of Helsinki.

    Group homepage: http://www.cs.helsinki.fi/group/seco/

-->

<xsl:stylesheet version="1.0" xmlns:bm="&bm;" xmlns:fms="&fms;" xmlns:html="&html;" xmlns:java="&java;" xmlns:ogt="&ogt;" xmlns:owl="&owl;" xmlns:rdf="&rdf;" xmlns:rdfs="&rdfs;" xmlns:swhg="&swhg;" xmlns:ui="&ui;" xmlns:uim="&uim;" xmlns:xsd="&xsd;" xmlns:xsl="&xsl;" xmlns:i18n="&i18n;" xmlns:query="&query;">
    <xsl:output doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" encoding="iso-8859-1" indent="yes" media-type="text/xml" method="xml" omit-xml-declaration="no" standalone="yes" version="1.0"/>

	<xsl:include href="xhtmlHelper.xslt" />

	<xsl:template match="rdf:RDF">
		 <html xmlns="http://www.w3.org/1999/xhtml">
            <head>
                <title>
                    <i18n:text>MuseoSuomi</i18n:text>
                </title>
                <meta content="text/html;charset=ISO-8859-1" http-equiv="Content-Type"/>
                <meta content="text/css" http-equiv="Content-Style-Type"/>
                <meta content="Semantic Web" name="description" i18n:attr="content"/>
                <meta content="Semantic web, fmsweb" name="keywords" i18n:attr="content"/>
                <link href="/content/stylesheets/web.css" rel="stylesheet" title="FMS-stylesheet basic" type="text/css"/>
            </head>
            <body>
           <!--     <xsl:call-template name="itemHeader"/>  -->
                <table>
                    <xsl:for-each select="ogt:Facet/ogt:topicOf/bm:Bookmark">
                        <tr>
                            <td valign="top" width="300" align="center">
       							<xsl:for-each select="fms:www_kuvatiedostonimi">
    				                <a href="/images/originals{substring-after(text(),'/home/group/seco/public_html/intra/Museo')}">
                                        <img src="/images{substring-after(text(),'/home/group/seco/public_html/intra/Museo')}" />
                                    </a>
                                    <br/>
    							</xsl:for-each>
                            </td>
                            <td valign="top">
            	                <xsl:call-template name="properties" />
            	                <xsl:call-template name="categories" />
                            </td>
                        </tr>
                        <tr><td colspan="2"><hr/></td></tr>
                    </xsl:for-each>
                </table>
			</body>
		</html>
	</xsl:template>
	
	<xsl:template name="properties">
	    <div class="property"><span class="propertyDefinition"><i18n:text>Nimike</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:label" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Materiaali</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_materiaali" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Valmistaja</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_tekija" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Valmistuspaikka</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_valmistuspaikka" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Valmistusaika</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_valmistusaika" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Valmistustekniikka</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_valmistustapa" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Käyttäjä</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_kayttaja" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Käyttöpaikka</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_kayttopaikka" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Asiasana</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_asiasana" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Mitat</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_mitat" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Museokokoelma</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_museokokoelma" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Vastuumuseo</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_vastuumuseo" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Asiasanasto</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_asiasanasto" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>Esineen numero</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_numero" /></span></div>	
	    <div class="property"><span class="propertyDefinition"><i18n:text>ID</i18n:text>: </span><span class="properyValue"><xsl:value-of select="fms:www_esineid" /></span></div>	

		<div class="description"><xsl:value-of select="fms:www_kuvailu" /></div>
	</xsl:template>

	<xsl:template name="categories">
	    <div class="itemcategories">
    	    <xsl:apply-templates mode="root" select="/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories">
    	        <xsl:with-param name="curbm" select="."/>
   	        </xsl:apply-templates>
	    </div>
    </xsl:template>
    
    <xsl:template match="ogt:Category" mode="root">
        <xsl:param name="curbm"/>
        <xsl:variable name="catid" select="@ogt:catid"/>
        <div class="facet">
            <div class="itemfacetheader">
                <div class="root"><xsl:value-of select="@rdfs:label"/>:</div>
                <ul class="categorylist">
                	<xsl:apply-templates mode="category" select="$curbm/bm:hasTopic/ogt:Category[ogt:hasRoot/ogt:Category/@ogt:catid=$catid]"/>
            	</ul>
            </div>
        </div>
    </xsl:template>

    <xsl:template match="ogt:Category" mode="category">
        <li class="categorylistitem">
            <xsl:apply-templates mode="path" select="ogt:hasRoot/ogt:Category/ogt:subCategories/ogt:Category">
                <xsl:with-param name="isFirst">true</xsl:with-param>
            </xsl:apply-templates>
            <div class="topic">
                <xsl:if test="ogt:hasRoot/ogt:Category/ogt:subCategories/ogt:Category">
                    &gt;
                </xsl:if>
<!--				<a href="&main;{$prefs}&amp;n={java:net.URLEncoder.encode(@ogt:catid)}&amp;g=c{java:net.URLEncoder.encode(@ogt:catid)}"> -->
					<i><xsl:value-of select="@rdfs:label"/></i>
<!--				</a> -->
            </div>
        </li>
    </xsl:template>
        
        <!-- Path with every category selectable -->
    <xsl:template match="ogt:Category" mode="path">
        <xsl:param name="isFirst"/>
        <div class="topicPath">
            <xsl:if test="not($isFirst)">
                &gt;
            </xsl:if>
<!--            <a href="&main;{$prefs}&amp;n={java:net.URLEncoder.encode(@ogt:catid)}&amp;g=c{java:net.URLEncoder.encode(@ogt:catid)}"> -->
                <xsl:value-of select="@rdfs:label"/>
<!--            </a> -->
        </div>
		<xsl:apply-templates mode="path" select="ogt:subCategories"/>
    </xsl:template>

</xsl:stylesheet>
