<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
    <!ENTITY % fmsentities PUBLIC
   "Museosuomi//ENTITIES Namespaces//EN//XML"
   "fmsentities.pen">
   %fmsentities;
]>
<!--

    File CVS Id: $Id: webMain.xslt,v 1.24 2004/03/22 08:44:19 jiemakel Exp $   
    This file is created by the Semantic Computinhelpg Research Group as a
    part of the Semantic Web project in 2002-2004 at Helsinki Institute
    for Information Technology (HIIT) and University of Helsinki.

    Group homepage: http://www.cs.helsinki.fi/group/seco/

-->

<xsl:stylesheet version="1.0" xmlns:page="&page;" xmlns:bm="&bm;" xmlns:fms="&fms;" xmlns:html="&html;" xmlns:java="&java;" xmlns:ogt="&ogt;" xmlns:owl="&owl;" xmlns:rdf="&rdf;" xmlns:rdfs="&rdfs;" xmlns:swhg="&swhg;" xmlns:ui="&ui;" xmlns:uim="&uim;" xmlns:xsd="&xsd;" xmlns:xsl="&xsl;" xmlns:i18n="&i18n;" xmlns:query="&query;">
    <xsl:output doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" encoding="iso-8859-1" indent="yes" media-type="text/xml" method="xml" omit-xml-declaration="no" standalone="yes" version="1.0"/>

	<xsl:include href="xhtmlHelper.xslt" />
    
    <!-- Root match -->
    <xsl:template match="rdf:RDF">
        <html xmlns="http://www.w3.org/1999/xhtml">
            <head>
                <title>
                    <i18n:text>MuseoSuomi</i18n:text>
                </title>
                <meta content="text/html;charset=ISO-8859-1" http-equiv="Content-Type"/>
                <meta content="text/css" http-equiv="Content-Style-Type"/>
                <meta content="Semantic Web" name="description" i18n:attr="content"/>
                <meta content="Semantic web, fmsweb" name="keywords" i18n:attr="content"/>
                <link href="/content/stylesheets/web.css" rel="stylesheet" title="FMS-stylesheet basic" type="text/css"/>
            </head>
            <body>
                <xsl:call-template name="searchHeader"/>
                <table cellpadding="6">
                <xsl:apply-templates select="/rdf:RDF/ui:UState/ui:error"/>
                <xsl:choose>
                   <xsl:when test="/rdf:RDF/ui:UState/ui:showBookmarks='false'">
                       <tr>
                           <td valign="top" width="100%" colspan="3">
                                <xsl:call-template name="keywordForm"/>
                           </td>
                       </tr>
                       <tr>
                           <xsl:call-template name="categorySearchFull"/>
                       </tr>
                   </xsl:when>
                   <xsl:otherwise>
                       <tr>
                           <td valign="top" width="33%">
                                <xsl:call-template name="keywordForm"/>
                                <xsl:apply-templates select="/rdf:RDF/ui:UState/swhg:NearestLocation/swhg:nearest"/>
                                <xsl:call-template name="projectedFromCategories"/>
                                <xsl:call-template name="keywordCategories"/>
                                <xsl:call-template name="categorySearch"/>
                            </td><td valign="top">
                                <xsl:call-template name="constraints"/>
                                <xsl:call-template name="Results"/>
                            </td>
                         </tr> 
                   </xsl:otherwise>
               </xsl:choose>
                </table>
                <hr/>
            </body>
        </html>
    </xsl:template>

    <xsl:template name="Results">
        <div id="helpOrResults" valign="top">
            <a name="#tulokset">
					<xsl:apply-templates select="ogt:Facet" mode="results"/>
			</a>
        </div>
    </xsl:template>
    
    <xsl:template match="ui:error">
    	<tr>
    	   <td colspan="2">
    	        <div class="error"><b>Virhe:</b> <xsl:apply-templates/></div>
    	   </td>
        </tr>
    </xsl:template>
    
    <xsl:template name="bookmarks">
		<xsl:param name="category" select="."/>
		<div class="bookmarks">
            <table class="bookmarktable">
                <xsl:for-each select="ogt:topicOf/bm:Bookmark">
                    <xsl:if test="(position()-1) mod 4 = 0">
                    <xsl:variable name="curpos" select="position()"/>
                        <tr>
                            <td valign="center" align="center" class="bookmarkcell">
                                <xsl:apply-templates mode="image" select="../bm:Bookmark[position()=$curpos]"/>
                            </td>
                            <td valign="center" align="center" class="bookmarkcell">
                                <xsl:apply-templates mode="image" select="../bm:Bookmark[position()=$curpos+1]"/>
                            </td>
                            <td valign="center" align="center" class="bookmarkcell">
                                <xsl:apply-templates mode="image" select="../bm:Bookmark[position()=$curpos+2]"/>
                            </td>
                            <td valign="center" align="center" class="bookmarkcell">
                                <xsl:apply-templates mode="image" select="../bm:Bookmark[position()=$curpos+3]"/>
                            </td>
                        </tr>
                         <tr>
                            <td valign="top" align="center" class="bookmarkcell">
                                <xsl:apply-templates mode="label" select="../bm:Bookmark[position()=$curpos]"/>
                            </td>
                            <td valign="top" align="center" class="bookmarkcell">
                                <xsl:apply-templates mode="label" select="../bm:Bookmark[position()=$curpos+1]"/>
                            </td>
                            <td valign="top" align="center" class="bookmarkcell">
                                <xsl:apply-templates mode="label" select="../bm:Bookmark[position()=$curpos+2]"/>
                            </td>
                            <td valign="top" align="center" class="bookmarkcell">
                                <xsl:apply-templates mode="label" select="../bm:Bookmark[position()=$curpos+3]"/>
                            </td>
                         </tr>
                     </xsl:if>
                </xsl:for-each>
            </table>
            
		</div>
    </xsl:template>

    <!-- To prevent leak into results in case none of the above matches -->
    <xsl:template match="ogt:Facet" mode="results"/>

    <!-- Category search block -->
    <xsl:template name="categorySearch">
        <div id="categorySearch">
            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category"/>
        </div>
    </xsl:template>
    
    <xsl:template match="ogt:Category" mode="singleFacet">
                <xsl:variable name="rootcatid" select="fms:rootcatid"/>
                <xsl:choose>
                    <xsl:when test="/rdf:RDF/ogt:Facet[starts-with(ogt:facetSelector/@rdf:resource, '&query;c')]/ogt:subCategories/ogt:Category[fms:rootcatid = $rootcatid or ogt:hasRoot/ogt:Category/fms:rootcatid = $rootcatid]">
                        <xsl:apply-templates mode="root" select="/rdf:RDF/ogt:Facet[starts-with(ogt:facetSelector/@rdf:resource, '&query;c')]/ogt:subCategories/ogt:Category[fms:rootcatid = $rootcatid or ogt:hasRoot/ogt:Category/fms:rootcatid = $rootcatid]"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <div class="facet">
                            <div class="headerC{$rootcatid}">
                                <span class="root">
                                <a name="Fc{$rootcatid}">
                                    <xsl:value-of select="@rdfs:label"/>
                                </a>
                                </span>
                            </div>
                            <div class="categories">
                                <span class="filtered">Ei valittavia kategorioita</span>
                            </div>
                        </div>
                    </xsl:otherwise>
                </xsl:choose>
    </xsl:template>
    
    <xsl:template name="categorySearchFull">
                      <td valign="top" width="33%">    	
                            <div id="categorySearch">
	                            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category[fms:rootcatid=0]"/>
	                            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category[fms:rootcatid=1]"/>
                            </div>
                       </td>
                      <td valign="top" width="33%">    	
                            <div id="categorySearch">
	                            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category[fms:rootcatid=2]"/>
	                            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category[fms:rootcatid=3]"/>
	                            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category[fms:rootcatid=4]"/>
                            </div>
                       </td>
                      <td valign="top" width="33%">    	
                            <div id="categorySearch">
	                            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category[fms:rootcatid=5]"/>
	                            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category[fms:rootcatid=6]"/>
	                            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category[fms:rootcatid=7]"/>
	                            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category[fms:rootcatid=8]"/>
                            </div>
                       </td>
<!--                        <td valign="top" width="33%">
                            <div id="categorySearch">
	                            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category[position() &lt;= count(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category) div 3]"/>
                            </div>
                        </td>
                        <td valign="top" width="33%">
                            <div id="categorySearch">
	                            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category[position() &gt; count(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category) div 3 and position() &lt;= (count(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category) div 3)*2]"/>
                            </div>
                        </td>
                        <td valign="top" width="33%">
                            <div id="categorySearch">
	                            <xsl:apply-templates mode="singleFacet" select="ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category[position() &gt; (count(/rdf:RDF/ogt:Facet[ogt:facetSelector/@rdf:resource='&query;roots']/ogt:subCategories/ogt:Category) div 3)*2]"/>
                            </div>
                        </td> -->
    </xsl:template>

    <!-- Keyword search form block -->
    <xsl:template name="keywordForm">
        <div id="keywordForm">
            <form action="&home;" method="get" name="keywordSearch">
                <xsl:call-template name="fustate"/>
				<b><i18n:text>Sanahaku:</i18n:text></b>
                <input name="nk" size="25" type="text" value=""/>
<!--                <input name="k" size="25" type="text" value="{$keywords}"/> -->
        		<input type="submit" value="Hae" i18n:attr="value" />
                <xsl:if test="/rdf:RDF/ui:UState/ui:showBookmarks='true'">
                	<input type="checkbox" name="refine" value="true" /> <span class="nowrap">tarkenna hakua</span>
                </xsl:if>
            </form>
        </div>
    </xsl:template>

    <!-- Keyword matching categories -->
    <xsl:template name="keywordCategories">
        <div id="keywordCategories">
            <!-- Keyword matching categories -->
            <xsl:for-each select="ogt:Facet[starts-with(ogt:facetSelector/@rdf:resource, '&query;k')]">
                <div class="facet">
                    <xsl:variable name="keyword" select="ogt:facetSelector/@rdfs:label"/>
                    <div class="headerKeyword">
                        <span class="root">Hakusana: </span> 
                        <span class="keyword">
                            <a name="Fk{$keyword}">
								<xsl:value-of select="$keyword"/>
							</a>
						</span>
						<xsl:if test="/rdf:RDF/ui:UState/ui:showBookmarks = 'true' and (not(/rdf:RDF/ui:UState/ui:groupBy/@ui:keyword) or /rdf:RDF/ui:UState/ui:groupBy/@ui:keyword != $keyword)">
							<xsl:call-template name="groupBy">
								<xsl:with-param name="mode">k</xsl:with-param>
								<xsl:with-param name="id" select="$keyword"/>
							</xsl:call-template>
						</xsl:if>
                        <xsl:call-template name="remove">
                            <xsl:with-param name="action" select="concat('&home;', $prefs, $cstate, $lstate, $pstate, $kstate, '&amp;rk=', $keyword)"/>
                        </xsl:call-template>
                    </div>
                    <xsl:choose>
                        <xsl:when test="ogt:subCategories/ogt:Category">
                            <div class="categories">
                                <xsl:apply-templates mode="keyword" select="ogt:subCategories/ogt:Category">
                                    <xsl:with-param name="keyword"><xsl:value-of select="$keyword"/></xsl:with-param>
                                </xsl:apply-templates>
                                <xsl:if test="count(ogt:subCategories/ogt:Category) &lt; number(ogt:subCategoryHits)">
                                    <div class="more">
                                        (<a href="&home;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}&amp;e=k{$keyword}#Fk{$keyword}">näytä kaikki <xsl:value-of select="ogt:subCategoryHits"/></a>)
                                    </div>
                                </xsl:if>
                            </div>
                        </xsl:when>
                        <xsl:otherwise>
                            <div class="categories">
                                <span class="filtered">Ei valittavia kategorioita</span>
                            </div>
                        </xsl:otherwise>
                    </xsl:choose>
                  </div>
            </xsl:for-each>
        </div>
    </xsl:template>

    <xsl:template match="swhg:NearestLocation/swhg:nearest">
        <div id="locations">
                <div class="facet">
                    <div class="headerKeyword">
                        <span class="root">
                    	Koordinaatteja x=<xsl:value-of select="/rdf:RDF/ui:UState/ui:coordinates/@ui:x"/>,y=<xsl:value-of select="/rdf:RDF/ui:UState/ui:coordinates/@ui:y"/> lähellä sijaitsevat paikat
                        </span> 
						<xsl:if test="/rdf:RDF/ui:UState/ui:showBookmarks = 'true' and not(/rdf:RDF/ui:UState/ui:groupBy/@ui:coordinates)">
							<xsl:call-template name="groupBy">
								<xsl:with-param name="mode">l</xsl:with-param>
								<xsl:with-param name="id" select="''"/>
							</xsl:call-template>
						</xsl:if>
                        <xsl:call-template name="remove">
                            <xsl:with-param name="action" select="concat('&home;', $prefs, $pstate, $cstate, $kstate)"/>
                        </xsl:call-template>
                    </div>

	                <div class="categories">
	                	<xsl:apply-templates select="swhg:location"/>
	                </div>
                  </div>
        </div>
    </xsl:template>
    
    <xsl:template match="swhg:NearestLocation/swhg:nearest/swhg:location">
	    <div class="category">
                        <a href="&home;{$prefs}{$cstate}{$kstate}&amp;p={java:net.URLEncoder.encode(@rdf:resource)}&amp;g=p{java:net.URLEncoder.encode(@rdf:resource)}">
                        <xsl:value-of select="@rdfs:label"/>
                        </a>
			 	<xsl:text> (</xsl:text><xsl:value-of select="@swhg:distance"/><xsl:text>)</xsl:text>
        </div>
	</xsl:template>
    

    <!-- projectedFrom matching categories -->
    <xsl:template name="projectedFromCategories">
        <div id="projectedFromCategories">
            <!-- projectedFrom matching categories -->
            <xsl:for-each select="ogt:Facet[starts-with(ogt:facetSelector/@rdf:resource, '&query;p')]">
                <div class="facet">
                    <xsl:variable name="keyword" select="ogt:facetSelector/@rdfs:label"/>
                    <div class="headerProjectionOf">
                        <span class="root">Liittyy 
                            <xsl:choose>
                                <xsl:when test="starts-with($keyword,'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-paikat')">
                                  paikkaan: 
                                </xsl:when>
                                <xsl:otherwise>
                                    ontologialuokkaan:
                                </xsl:otherwise>
                            </xsl:choose>
                        </span> 
                        <span class="keyword">
                            <a name="Fk{$keyword}">
                                <xsl:apply-templates mode="projectedFromPath" select="ogt:subCategories/ogt:Category[1]/ogt:hasRoot/ogt:Category/ogt:subCategories"/>
								<xsl:value-of select="ogt:subCategories/ogt:Category/@rdfs:label"/>
							</a>
						</span>
						<xsl:if test="/rdf:RDF/ui:UState/ui:showBookmarks = 'true' and (not(/rdf:RDF/ui:UState/ui:groupBy/@ui:projectedFrom) or /rdf:RDF/ui:UState/ui:groupBy/@ui:projectedFrom != $keyword)">
							<xsl:call-template name="groupBy">
								<xsl:with-param name="mode">p</xsl:with-param>
								<xsl:with-param name="id" select="$keyword"/>
							</xsl:call-template>
						</xsl:if>
                        <xsl:call-template name="remove">
                            <xsl:with-param name="action" select="concat('&home;', $prefs, $pstate, $cstate, $lstate, $kstate, '&amp;rp=', java:net.URLEncoder.encode($keyword))"/>
                        </xsl:call-template>
                    </div>
                    <xsl:choose>
                        <xsl:when test="ogt:subCategories/ogt:Category">
                            <div class="categories">
                                <xsl:apply-templates mode="projectedFrom" select="ogt:subCategories/ogt:Category">
                                    <xsl:with-param name="projectedFrom"><xsl:value-of select="$keyword"/></xsl:with-param>
                                </xsl:apply-templates>
                                <xsl:if test="count(ogt:subCategories/ogt:Category) &lt; number(ogt:subCategoryHits)">
                                    <div class="more">
                                        (<a href="&home;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}&amp;e=p{$keyword}#Fp{$keyword}">näytä kaikki <xsl:value-of select="ogt:subCategoryHits"/></a>)
                                    </div>
                                </xsl:if>
                            </div>
                        </xsl:when>
                        <xsl:otherwise>
                            <div class="categories">
                                <span class="filtered">Ei valittavia kategorioita</span>
                            </div>
                        </xsl:otherwise>
                    </xsl:choose>
                  </div>
            </xsl:for-each>
        </div>
    </xsl:template>
      
    <xsl:template name="category">
        <xsl:param name="label"/>
        <xsl:param name="bookmarkHits"/>
		<div>
            <xsl:attribute name="class">
                <xsl:choose>
                    <xsl:when test="$bookmarkHits > 0">category</xsl:when>
                    <xsl:otherwise>filtered</xsl:otherwise>
                </xsl:choose>
            </xsl:attribute>
            <xsl:copy-of select="$label"/>
            <xsl:if test="$bookmarkHits">
				<span class="bookmarkHits">
					<xsl:text> (</xsl:text><xsl:value-of select="$bookmarkHits"/><xsl:text>)</xsl:text>
				</span>
            </xsl:if>
            <xsl:if test="not(position() = last())">
                <xsl:text>,&nbsp;</xsl:text>
            </xsl:if>
       </div>
    </xsl:template>
    
	<xsl:template match="ogt:Category" name="categoryLabelWithRoot">
		<xsl:param name="category" select="."/>
		<xsl:if test="$category/ogt:hasRoot">
			<xsl:call-template name="getLabel">
				<xsl:with-param name="node" select="$category/ogt:hasRoot"/>
			</xsl:call-template>
			&gt;
		</xsl:if>
		<xsl:call-template name="getLabel"/>
	</xsl:template>
	

    <!-- Root categories -->

    <xsl:template match="ogt:Category" mode="root">
        <xsl:if test="ogt:hasRoot or ogt:subCategories">
            <div class="facet">
                <xsl:variable name="catid" select="@ogt:catid"/>
                <div class="headerC{descendant-or-self::fms:rootcatid}">
                    <xsl:apply-templates mode="facetPath" select="ogt:hasRoot"/>
                    <xsl:choose>
                        <xsl:when test="not(ogt:hasRoot)">
                            <span class="root">
                            <a name="Fc{fms:rootcatid}">
                                <xsl:value-of select="@rdfs:label"/>
                            </a>
                            </span>
                        </xsl:when>
                        <xsl:otherwise>
                            <span class="selected">
                            <a name="Fc{fms:rootcatid}">
                                <xsl:value-of select="@rdfs:label"/>
                            </a>
                            </span>
                        </xsl:otherwise>
                    </xsl:choose>
					<xsl:text> </xsl:text>
                    <span class="showTree">
                        (<a href="tree?{$ustate}&amp;t={java:net.URLEncoder.encode(@ogt:catid)}{$groupBy}{$pstate}">
							<i18n:text>koko luokittelu</i18n:text>
						</a>)
                    </span>
                    <!--<xsl:if test="/rdf:RDF/ui:UState/ui:showBookmarks = 'true' and (not(/rdf:RDF/ui:UState/ui:groupBy/@ui:catid) or not(starts-with(/rdf:RDF/ui:UState/ui:groupBy/@ui:catid, @ogt:catid)))">-->
                    <xsl:if test="/rdf:RDF/ui:UState/ui:showBookmarks = 'true' and (not(/rdf:RDF/ui:UState/ui:groupBy/@ui:catid) or /rdf:RDF/ui:UState/ui:groupBy/@ui:catid != @ogt:catid)">
                        <xsl:call-template name="groupBy">
                            <xsl:with-param name="mode">c</xsl:with-param>
                            <xsl:with-param name="id" select="$catid"/>
                        </xsl:call-template>
                    </xsl:if>
                </div>
                <xsl:choose>
                    <xsl:when test="ogt:subCategories/ogt:Category">
                        <div class="categories">
                            <xsl:apply-templates mode="subCategory" select="ogt:subCategories/ogt:Category"/>
                            <xsl:if test="count(ogt:subCategories/ogt:Category) &lt; number(ogt:subCategoryHits)">
                                <div class="more">
                                    (<a href="&home;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}&amp;e=c{java:net.URLEncoder.encode($catid)}#Fc{fms:rootcatid}">näytä kaikki <xsl:value-of select="ogt:subCategoryHits"/></a>)
                                </div>
                            </xsl:if>
                        </div>
                    </xsl:when>
                    <xsl:otherwise>
                        <div class="categories">
                            <span class="filtered">Ei valittavia kategorioita</span>
                        </div>
                    </xsl:otherwise>
                </xsl:choose>
            </div>
        </xsl:if>
    </xsl:template>

    <!-- Sub categories -->
    <xsl:template match="ogt:Category" mode="subCategory">
        <xsl:choose>
            <xsl:when test="ogt:bookmarkHits > 0">
                <xsl:call-template name="category">
                    <xsl:with-param name="label">
                        <a href="&home;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}&amp;n={java:net.URLEncoder.encode(@ogt:catid)}&amp;g=c{java:net.URLEncoder.encode(@ogt:catid)}">
                            <xsl:call-template name="getLabel">
                                <xsl:with-param name="node" select="."/>
                            </xsl:call-template>
                        </a>
                    </xsl:with-param>
                    <xsl:with-param name="bookmarkHits" select="ogt:bookmarkHits"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:call-template name="category">
                    <xsl:with-param name="label">
                            <xsl:call-template name="getLabel">
                                <xsl:with-param name="node" select="."/>
                            </xsl:call-template>
                    </xsl:with-param>
                </xsl:call-template>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
    <!-- Keyword match categories -->
    <xsl:template match="ogt:Category" mode="keyword">
        <xsl:param name="keyword"/>
        <xsl:variable name="label">
            <xsl:call-template name="getLabel">
                <xsl:with-param name="node" select="."/>
            </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
            <xsl:when test="ogt:bookmarkHits > 0 and ogt:hasRoot">
                <xsl:call-template name="category">
                    <xsl:with-param name="label">
                        <xsl:apply-templates mode="keywordPath" select="ogt:hasRoot"/>
                        <xsl:if test="ogt:hasRoot/ogt:Category/ogt:subCategories">
                        ... &gt;
                        </xsl:if>
                        <a href="&home;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}&amp;n={java:net.URLEncoder.encode(@ogt:catid)}&amp;g=c{java:net.URLEncoder.encode(@ogt:catid)}&amp;rk={$keyword}">
                            <xsl:call-template name="highlightKeyword">
                                <xsl:with-param name="label" select="$label"/>
                                <xsl:with-param name="keyword" select="$keyword"/>
                            </xsl:call-template>
                        </a>
                    </xsl:with-param>
                    <xsl:with-param name="bookmarkHits" select="ogt:bookmarkHits"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
            	<span class="inactive">
                <xsl:call-template name="category">
                    <xsl:with-param name="label">
                        <xsl:apply-templates mode="keywordPath" select="ogt:hasRoot"/>
                            <xsl:call-template name="highlightKeyword">
                                <xsl:with-param name="label" select="$label"/>
                                <xsl:with-param name="keyword" select="$keyword"/>
                            </xsl:call-template>
                    </xsl:with-param>
                    <xsl:with-param name="bookmarkHits" select="ogt:bookmarkHits"/>
                </xsl:call-template>
                </span>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <!-- projectedFrom match categories -->
    <xsl:template match="ogt:Category" mode="projectedFrom">
        <xsl:param name="projectedFrom"/>
        <xsl:variable name="label">
            <xsl:call-template name="getLabel">
                <xsl:with-param name="node" select="."/>
            </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
            <xsl:when test="ogt:bookmarkHits > 0">
                <xsl:call-template name="category">
                    <xsl:with-param name="label">
                        <xsl:apply-templates mode="keywordPath" select="ogt:hasRoot"/>
                        <a href="&home;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}&amp;n={java:net.URLEncoder.encode(@ogt:catid)}&amp;g=c{java:net.URLEncoder.encode(@ogt:catid)}&amp;rp={java:net.URLEncoder.encode($projectedFrom)}">
                            <xsl:value-of select="$label"/>
                        </a>
                    </xsl:with-param>
                    <xsl:with-param name="bookmarkHits" select="ogt:bookmarkHits"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:call-template name="category">
                    <xsl:with-param name="label">
                        <xsl:apply-templates mode="keywordPath" select="ogt:hasRoot"/>
                            <xsl:value-of select="$label"/>
                    </xsl:with-param>
                </xsl:call-template>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <!-- Grouped bookmarks -->
    <xsl:template name="bookmarkGroups">
        <xsl:param name="modifiers"/>
        <xsl:param name="incRoot"/>
        <xsl:param name="headerdef"/>
		<!-- Direct bookmarks -->
        <xsl:variable name="showdirectNoRoot" select="not(/rdf:RDF/ui:UState/ui:skipCategories)"/>
		<xsl:if test="$incRoot or $showdirectNoRoot">
    		<xsl:apply-templates mode="bookmarkGroup" select="ogt:subCategories/ogt:Category">
                <xsl:with-param name="modifiers" select="$modifiers"/>
                <xsl:with-param name="incRoot" select="$incRoot"/>
                <xsl:with-param name="headerdef" select="$headerdef"/>
            </xsl:apply-templates>
        </xsl:if>
        <!-- Bookmarks of direct sub categories -->
		<xsl:apply-templates mode="bookmarkGroup" select="ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category">
            <xsl:with-param name="modifiers" select="$modifiers"/>
            <xsl:with-param name="incRoot" select="$incRoot"/>
            <xsl:with-param name="headerdef" select="$headerdef"/>
        </xsl:apply-templates>
        <!-- Bookmarks not found in category hierarchy used for grouping -->
        <xsl:if test="ogt:topicOf/bm:Bookmark and ((not($incRoot) and count(ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category) &lt; /rdf:RDF/ui:UState/ui:maxGroups) or ($incRoot and count(ogt:subCategories/ogt:Category) &lt; /rdf:RDF/ui:UState/ui:maxGroups))">
			<xsl:variable name="bmcount" select="count(ogt:topicOf/bm:Bookmark)"/>
            <div class="bookmarkGroup">
                <div class="header">
                    <span class="selected">Muita kohteita</span>
                    <xsl:text> </xsl:text>
						<xsl:choose>
						    <xsl:when test="/rdf:RDF/ui:UState/ui:skipBookmarks[not(@ui:category)]/@ui:limit">
						        <xsl:value-of select="/rdf:RDF/ui:UState/ui:skipBookmarks[not(@ui:category)]/@ui:limit + 1"/>
						        <xsl:text>-</xsl:text>
						        <xsl:value-of select="/rdf:RDF/ui:UState/ui:skipBookmarks[not(@ui:category)]/@ui:limit + $bmcount"/>
					        </xsl:when>
					        <xsl:otherwise>
					            1-<xsl:value-of select="$bmcount"/>
    			            </xsl:otherwise>
					    </xsl:choose>
						<xsl:text>/</xsl:text><xsl:value-of select="ogt:remainder"/>
                    <span class="showAll">
                        (<a href="&home;{$prefs}{$pstate}{$cstate}{$lstate}{$kstate}&amp;g=">näytä ilman ryhmittelyä</a>)
                    </span>
                </div>
                <xsl:call-template name="bookmarks"/>
                <xsl:call-template name="pagination">
                    <xsl:with-param name="category" select="."/>
                    <xsl:with-param name="current" select="/rdf:RDF/ui:UState/ui:skipBookmarks[not(@ui:category)]/@ui:limit"/>
                    <xsl:with-param name="maxBookmarks" select="ogt:remainder"/>
                </xsl:call-template>
            </div>
        </xsl:if>
        <xsl:if test="(not($incRoot) and count(ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category) &lt; /rdf:RDF/ui:UState/ui:maxGroups) or ($incRoot and count(ogt:subCategories/ogt:Category) &lt; /rdf:RDF/ui:UState/ui:maxGroups)">
            <xsl:apply-templates select="/rdf:RDF/ui:UState/swhg:NearestMuinainen"/>
        </xsl:if>
        <xsl:call-template name="categoryPagination">
            <xsl:with-param name="isRoot" select="$incRoot"/>
        </xsl:call-template>
    </xsl:template>

        <!-- Results grouped by category -->
    <xsl:template match="ogt:Facet[ogt:facetSelector/@rdf:resource = '&query;bookmarksByCategory']" mode="results">
        <h4>
            Kohteet ryhmiteltyinä kategorian 
            <i><xsl:value-of select="ogt:subCategories/ogt:Category/@rdfs:label"/></i> 
            mukaisesti
        </h4>
        <div class="itemActions">
            <div class="showAll" align="left">
                (<a href="?{$ustate}&amp;g=">näytä ilman ryhmittelyä</a>)
            </div>        
        </div>
        <xsl:call-template name="bookmarkGroups">
	        <xsl:with-param name="headerdef" select="concat('C',descendant::fms:rootcatid)"/>
		</xsl:call-template>
    </xsl:template>

	<!-- Results grouped by keyword -->
    <xsl:template match="ogt:Facet[ogt:facetSelector/@rdf:resource = '&query;bookmarksByKeyword']" mode="results">
        <xsl:variable name="keyword" select="ogt:facetSelector/@rdfs:label"/>
        <h4>
            Kohteet ryhmiteltyinä hakusanan 
            <i><xsl:value-of select="$keyword"/></i> 
            mukaisesti
            
        </h4>
        <div class="itemActions">
            <div class="showAll">
                (<a href="?{$ustate}&amp;g=">näytä ilman ryhmittelyä</a>)
            </div>
        </div>
        <xsl:call-template name="bookmarkGroups">
            <xsl:with-param name="modifiers" select="concat('&amp;rk=', $keyword)"/>
            <xsl:with-param name="incRoot">true</xsl:with-param>
            <xsl:with-param name="headerdef" select="'Keyword'"/>
        </xsl:call-template>
    </xsl:template>
	
	 <xsl:template match="ogt:Facet[ogt:facetSelector/@rdf:resource = '&query;bookmarksByCoordinates']" mode="results">
 	         <xsl:variable name="keyword" select="ogt:facetSelector/@rdfs:label"/>
 	         <h4>
 	             Kohteet ryhmiteltyinä koordinaatteja <i>x=<xsl:value-of select="/rdf:RDF/ui:UState/ui:coordinates/@ui:x"/>, y=<xsl:value-of select="/rdf:RDF/ui:UState/ui:coordinates/@ui:y"/></i> lähellä sijaitsevien paikkojen
 	             mukaisesti
 	             
 	         </h4>
 	         <div class="itemActions">
 	             <div class="showAll">
 	                 <xsl:value-of select="ogt:bookmarkHits"/> kohdetta (<a href="?{$ustate}&amp;g=">näytä ilman ryhmittelyä</a>)
 	             </div>
 	         </div>
 	         <xsl:call-template name="bookmarkGroups">
 	             <xsl:with-param name="modifiers" select="concat('&amp;rp=', java:net.URLEncoder.encode($keyword))"/>
 	             <xsl:with-param name="incRoot">true</xsl:with-param>
 	             <xsl:with-param name="headerdef" select="'ProjectionOf'"/>
 	         </xsl:call-template>
 	     </xsl:template>
	
	<!-- Results grouped by projectedFrom -->
    <xsl:template match="ogt:Facet[ogt:facetSelector/@rdf:resource = '&query;bookmarksByProjectedFrom']" mode="results">
        <xsl:variable name="keyword" select="ogt:facetSelector/@rdfs:label"/>
        <h4>
            Kohteet ryhmiteltyinä 
							<xsl:choose>
                                <xsl:when test="starts-with(ogt:facetSelector/@rdfs:label,'http://www.cs.helsinki.fi/group/seco/ns/2004/03/18-paikat')">
                                  <xsl:text>paikan </xsl:text>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:text>ontologialuokan </xsl:text>
                                </xsl:otherwise>
                            </xsl:choose>
            <i><xsl:value-of select="ogt:subCategories/ogt:Category/@rdfs:label"/></i> 
            mukaisesti
            
        </h4>
        <div class="itemActions">
            <div class="showAll">
                <xsl:value-of select="ogt:bookmarkHits"/> kohdetta (<a href="?{$ustate}&amp;g=">näytä ilman ryhmittelyä</a>)
            </div>
        </div>
        <xsl:call-template name="bookmarkGroups">
            <xsl:with-param name="modifiers" select="concat('&amp;rp=', java:net.URLEncoder.encode($keyword))"/>
            <xsl:with-param name="incRoot">true</xsl:with-param>
            <xsl:with-param name="headerdef" select="'ProjectionOf'"/>
        </xsl:call-template>
    </xsl:template>

	<!-- Results ungrouped -->
    <xsl:template match="ogt:Facet[ogt:facetSelector/@rdf:resource = '&query;bookmarks']" mode="results">
			<xsl:variable name="bmcount" select="count(ogt:topicOf/bm:Bookmark)"/>
		<h4>
			Kohteet - ei ryhmittelyä
		</h4>
        <div class="itemActions">
        </div>
        <div class="header">
					<span class="bookmarkHits">
						Kohteet 
						<xsl:choose>
						    <xsl:when test="/rdf:RDF/ui:UState/ui:skipBookmarks[not(@ui:category)]/@ui:limit">
						        <xsl:value-of select="/rdf:RDF/ui:UState/ui:skipBookmarks[not(@ui:category)]/@ui:limit + 1"/>
						        <xsl:text>-</xsl:text>
						        <xsl:value-of select="/rdf:RDF/ui:UState/ui:skipBookmarks[not(@ui:category)]/@ui:limit + $bmcount"/>
					        </xsl:when>
					        <xsl:otherwise>
					            1-<xsl:value-of select="$bmcount"/>
    			            </xsl:otherwise>
					    </xsl:choose>
						<xsl:text>/</xsl:text><xsl:value-of select="ogt:bookmarkHits"/>
                    </span>
<!--			<span class="selected">Kohteet (<xsl:value-of select="ogt:bookmarkHits"/> kpl)</span> -->
		</div>
        <xsl:call-template name="bookmarks"/>
        <xsl:call-template name="pagination">
            <xsl:with-param name="category" select="."/>
            <xsl:with-param name="amount" select="10"/>
            <xsl:with-param name="current" select="/rdf:RDF/ui:UState/ui:skipBookmarks[not(@ui:category)]/@ui:limit"/>
        </xsl:call-template>
	</xsl:template>
    
    
    
    <xsl:template match="swhg:NearestMuinainen">
            <div class="bookmarkGroup">
                <div class="header">
                    <span class="selected">Lähellä sijaitsevia muinaismuistoja</span>
                </div>
           		<div class="bookmarks">
		            <table class="bookmarktable">
		                <xsl:for-each select="swhg:nearest/swhg:location[position() &lt; /rdf:RDF/ui:UState/ui:maxBookmarks]">
		                    <xsl:if test="(position()-1) mod 4 = 0">
		                    <xsl:variable name="curpos" select="position()"/>
		                        <tr>
		                            <td valign="center" align="center" class="bookmarkcell">
		                                <xsl:apply-templates mode="image" select="../swhg:location[position()=$curpos]"/>
		                            </td>
		                            <td valign="center" align="center" class="bookmarkcell">
		                                <xsl:apply-templates mode="image" select="../swhg:location[position()=$curpos+1]"/>
		                            </td>
		                            <td valign="center" align="center" class="bookmarkcell">
		                                <xsl:apply-templates mode="image" select="../swhg:location[position()=$curpos+2]"/>
		                            </td>
		                            <td valign="center" align="center" class="bookmarkcell">
		                                <xsl:apply-templates mode="image" select="../swhg:location[position()=$curpos+3]"/>
		                            </td>
		                        </tr>
		                        <tr>
		                            <td valign="center" align="center" class="bookmarkcell">
		                                <xsl:apply-templates mode="label" select="../swhg:location[position()=$curpos]"/>
		                            </td>
		                            <td valign="center" align="center" class="bookmarkcell">
		                                <xsl:apply-templates mode="label" select="../swhg:location[position()=$curpos+1]"/>
		                            </td>
		                            <td valign="center" align="center" class="bookmarkcell">
		                                <xsl:apply-templates mode="label" select="../swhg:location[position()=$curpos+2]"/>
		                            </td>
		                            <td valign="center" align="center" class="bookmarkcell">
		                                <xsl:apply-templates mode="label" select="../swhg:location[position()=$curpos+3]"/>
		                            </td>
		                        </tr>
		                     </xsl:if>
		                </xsl:for-each>
		            </table>
				</div>
            </div>
    </xsl:template>
    
    <xsl:template match="swhg:NearestMuinainen/swhg:nearest/swhg:location" mode="label">
        <div class="bookmark">
            <xsl:value-of select="@rdfs:label"/>
			<xsl:text> (</xsl:text>
			<xsl:value-of select="@swhg:distance"/>
			<xsl:text>)</xsl:text>
        </div>
    </xsl:template>

    <xsl:template match="swhg:NearestMuinainen/swhg:nearest/swhg:location" mode="image">
        <div class="image">
        	<a href="&muin;{$ustate}&amp;sb={java:net.URLEncoder.encode(@rdf:resource)}"><img src="content/images/hy.gif"/></a>
        </div>
    </xsl:template>

	<xsl:template match="ogt:Category" name="bookmarkGroup" mode="bookmarkGroup">
		<xsl:param name="category" select="."/>
		<xsl:param name="modifiers"/>
		<xsl:param name="incRoot"/>
		<xsl:param name="headerdef"/>
		<xsl:if test="ogt:topicOf/bm:Bookmark">
            <xsl:variable name="isRoot" select="/rdf:RDF/ui:UState/ui:category[@ui:catid = $category/@ogt:catid]"/> 
            <xsl:variable name="bmcount" select="count($category/ogt:topicOf/bm:Bookmark)"/>
			<div class="bookmarkGroup">
			    <a name="bg{java:net.URLEncoder.encode(translate(@ogt:catid,'%','_'))}" />
				<div class="header{$headerdef}">
					<span class="groupTitle">
						<xsl:choose>
							<xsl:when test="$isRoot">
								<xsl:value-of select="$category/@rdfs:label"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:if test="$incRoot and $category/ogt:hasRoot">
									<xsl:apply-templates mode="keywordPath" select="$category/ogt:hasRoot/ogt:Category"/>
								</xsl:if>
								<a href="&home;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}&amp;n={java:net.URLEncoder.encode($category/@ogt:catid)}&amp;g=c{java:net.URLEncoder.encode($category/@ogt:catid)}{$modifiers}">
									<xsl:value-of select="$category/@rdfs:label"/>
								</a>
							</xsl:otherwise>
						</xsl:choose>
					</span>
                    <xsl:text>, </xsl:text>
					<span class="bookmarkHits">
						kohteet 
						<xsl:choose>
						    <xsl:when test="/rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category=$category/@ogt:catid]/@ui:limit">
						        <xsl:value-of select="/rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category=$category/@ogt:catid]/@ui:limit + 1"/>
						        <xsl:text>-</xsl:text>
						        <xsl:value-of select="/rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category=$category/@ogt:catid]/@ui:limit + $bmcount"/>
					        </xsl:when>
					        <xsl:otherwise>
					            1-<xsl:value-of select="$bmcount"/>
    			            </xsl:otherwise>
					    </xsl:choose>
						<xsl:text>/</xsl:text>
						<xsl:choose>
						   <xsl:when test="$category/ogt:directBookmarkHits">
						     <xsl:value-of select="$category/ogt:directBookmarkHits"/>
    				       </xsl:when>
						   <xsl:otherwise>
						     <xsl:value-of select="$category/ogt:bookmarkHits"/>
						   </xsl:otherwise>
						</xsl:choose>   
                        <xsl:if test="not(/rdf:RDF/ui:UState/ui:groupBy/@ui:catid) or $category/@ogt:catid != /rdf:RDF/ui:UState/ui:groupBy/@ui:catid">
                            <xsl:call-template name="groupBy">
                                <xsl:with-param name="mode">c</xsl:with-param>
                                <xsl:with-param name="id" select="$category/@ogt:catid"/>
                            </xsl:call-template>
                        </xsl:if>
                    </span>
					<xsl:if test="$isRoot and $bmcount &lt; $category/ogt:bookmarkHits">
						<span class="showAll">
							(<a href="&home;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$modifiers}&amp;g=">näytä kaikki</a>)
						</span>
					</xsl:if>
				</div>
                <xsl:call-template name="bookmarks">
					<xsl:with-param name="category" select="$category"/>
				</xsl:call-template>
				<xsl:choose>
    	    	    <xsl:when test="ogt:directBookmarkHits">
	        			<xsl:call-template name="pagination">
        				    <xsl:with-param name="category" select="$category"/>				    
        				    <xsl:with-param name="maxBookmarks" select="ogt:directBookmarkHits"/>
            		    </xsl:call-template>
    	    		</xsl:when>
    	    		<xsl:otherwise>
	        			<xsl:call-template name="pagination">
        				    <xsl:with-param name="category" select="$category"/>				    
        				    <xsl:with-param name="maxBookmarks" select="ogt:bookmarkHits"/>
            		    </xsl:call-template>
   	    		    </xsl:otherwise>
    		    </xsl:choose>
			</div>
		</xsl:if>
	</xsl:template>
	
    <!-- Single bookmark -->
    <xsl:template match="bm:Bookmark" mode="image">
            <div class="image">
                <xsl:choose>
                    <!-- direct bookmarks -->
                    <xsl:when test="ancestor::ogt:Category[1]/ogt:directBookmarkHits and /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category=current()/ancestor::ogt:Category[1]/@ogt:catid]">
                       <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc={java:net.URLEncoder.encode(ancestor::ogt:Category[1]/@ogt:catid)}:-1&amp;cb={java:net.URLEncoder.encode(ancestor::ogt:Category[1]/@ogt:catid)}:{count(preceding-sibling::bm:Bookmark) + /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category=current()/ancestor::ogt:Category[1]/@ogt:catid]/@ui:limit}">
                          <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                       </a>
                    </xsl:when>
                    <xsl:when test="ancestor::ogt:Category[1]/ogt:directBookmarkHits">
                       <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc={java:net.URLEncoder.encode(ancestor::ogt:Category[1]/@ogt:catid)}:-1&amp;cb={java:net.URLEncoder.encode(ancestor::ogt:Category[1]/@ogt:catid)}:{count(preceding-sibling::bm:Bookmark)}">
                          <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                       </a>
                    </xsl:when>
                    <!-- remainder -->
                    <xsl:when test="ancestor::node()/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category and /rdf:RDF/ui:UState/ui:skipCategories and not(ancestor::ogt:Category[1]) and /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category='']">
                        <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc={java:net.URLEncoder.encode(ancestor::node()/ogt:subCategories/ogt:Category/@ogt:catid)}:-{count(ancestor::node()/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category) + 2}&amp;cb=:{count(preceding-sibling::bm:Bookmark) + /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category='']/@ui:limit}">
                            <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                        </a>
                    </xsl:when>
                    <xsl:when test="ancestor::node()/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category and /rdf:RDF/ui:UState/ui:skipCategories and not(ancestor::ogt:Category[1])">
                        <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc={java:net.URLEncoder.encode(ancestor::node()/ogt:subCategories/ogt:Category/@ogt:catid)}:-{count(ancestor::node()/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category) + 2}&amp;cb=:{count(preceding-sibling::bm:Bookmark)}">
                            <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                        </a>
                    </xsl:when>
                    <xsl:when test="ancestor::node()/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category and not(ancestor::ogt:Category[1]) and /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category='']">
                        <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc={java:net.URLEncoder.encode(ancestor::node()/ogt:subCategories/ogt:Category/@ogt:catid)}:-{count(ancestor::node()/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category) + 2}&amp;cb=:{count(preceding-sibling::bm:Bookmark) + /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category='']/@ui:limit}">
                            <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                        </a>
                    </xsl:when>
                    <xsl:when test="ancestor::node()/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category and not(ancestor::ogt:Category[1])">
                        <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc={java:net.URLEncoder.encode(ancestor::node()/ogt:subCategories/ogt:Category/@ogt:catid)}:-{count(ancestor::node()/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category) + 2}&amp;cb=:{count(preceding-sibling::bm:Bookmark)}">
                            <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                        </a>
                    </xsl:when>
                    <xsl:when test="/rdf:RDF/ui:UState/ui:skipCategories and not(ancestor::ogt:Category[1]) and /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category='']">
                        <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc=:-{count(ancestor::node()/ogt:subCategories/ogt:Category) + 2}&amp;cb=:{count(preceding-sibling::bm:Bookmark) + /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category='']/@ui:limit}">
                            <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                        </a>
                    </xsl:when>
                    <xsl:when test="/rdf:RDF/ui:UState/ui:skipCategories and not(ancestor::ogt:Category[1])">
                        <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc=:-{count(ancestor::node()/ogt:subCategories/ogt:Category) + 2}&amp;cb=:{count(preceding-sibling::bm:Bookmark)}">
                            <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                        </a>
                    </xsl:when>
                    <xsl:when test="not(ancestor::ogt:Category[1]) and /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category='']">
                        <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc=:-{count(ancestor::node()/ogt:subCategories/ogt:Category) + 2}&amp;cb=:{count(preceding-sibling::bm:Bookmark) + /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category='']/@ui:limit}">
                            <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                        </a>
                    </xsl:when>
                    <xsl:when test="not(ancestor::ogt:Category[1])">
                        <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc=:-{count(ancestor::node()/ogt:subCategories/ogt:Category) + 2}&amp;cb=:{count(preceding-sibling::bm:Bookmark)}">
                            <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                        </a>
                    </xsl:when>
                    <!-- groups -->
                    <xsl:when test="/rdf:RDF/ui:UState/ui:skipCategories and /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category=current()/ancestor::ogt:Category[1]/@ogt:catid]">
                        <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc={java:net.URLEncoder.encode(ancestor::node()/ogt:subCategories/ogt:Category/@ogt:catid)}:-{count(ancestor::node()/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category) + 1}&amp;cb={java:net.URLEncoder.encode(ancestor::ogt:Category[1]/@ogt:catid)}:{count(preceding-sibling::bm:Bookmark) + /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category=current()/ancestor::ogt:Category[1]/@ogt:catid]/@ui:limit}">
                            <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                        </a>
                    </xsl:when>
                    <xsl:when test="/rdf:RDF/ui:UState/ui:skipCategories">
                        <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc={java:net.URLEncoder.encode(ancestor::node()/ogt:subCategories/ogt:Category/@ogt:catid)}:-{count(ancestor::node()/ogt:subCategories/ogt:Category/ogt:subCategories/ogt:Category) + 1}&amp;cb={java:net.URLEncoder.encode(ancestor::ogt:Category[1]/@ogt:catid)}:{count(preceding-sibling::bm:Bookmark)}">
                            <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                        </a>
                    </xsl:when>
                    <xsl:when test="/rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category=current()/ancestor::ogt:Category[1]/@ogt:catid]">
                        <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc={java:net.URLEncoder.encode(ancestor::ogt:Category[2]/@ogt:catid)}:{count(ancestor::ogt:Category[1]/preceding-sibling::node())}&amp;cb={java:net.URLEncoder.encode(ancestor::ogt:Category[1]/@ogt:catid)}:{count(preceding-sibling::bm:Bookmark) + /rdf:RDF/ui:UState/ui:skipBookmarks[@ui:category=current()/ancestor::ogt:Category[1]/@ogt:catid]/@ui:limit}">
                            <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                        </a>
                    </xsl:when>
                    <xsl:otherwise>
                        <a href="&item;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}{$groupBy}&amp;sb={java:net.URLEncoder.encode(@rdf:about)}&amp;cc={java:net.URLEncoder.encode(ancestor::ogt:Category[2]/@ogt:catid)}:{count(ancestor::ogt:Category[1]/preceding-sibling::node())}&amp;cb={java:net.URLEncoder.encode(ancestor::ogt:Category[1]/@ogt:catid)}:{count(preceding-sibling::bm:Bookmark)}">
                            <img src="/thumbnails{substring-after(fms:www_kuvatiedostonimi,'/home/group/seco/public_html/intra/Museo')}" />
                        </a>
                    </xsl:otherwise>
                </xsl:choose>
            </div>
    </xsl:template>

    <xsl:template match="bm:Bookmark" mode="label">
        <div class="bookmark">
            <xsl:value-of select="@rdfs:label"/>
			<xsl:text> (</xsl:text>
			<xsl:value-of select="translate(fms:www_numero,':',' ')"/>
			<xsl:text>)</xsl:text>
        </div>
    </xsl:template>
    
    <!-- Root category of a path -->
    <xsl:template match="ogt:Category" mode="facetPath">
        <span class="root"><xsl:value-of select="@rdfs:label"/></span>
        <xsl:text>:&nbsp;</xsl:text>
        <a href="&home;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}&amp;rc={java:net.URLEncoder.encode(@ogt:catid)}">kaikki</a>
        <xsl:text> &gt; </xsl:text>
        <xsl:apply-templates mode="path" select="ogt:subCategories"/>
    </xsl:template>

    <!-- Path with every category selectable -->
    <xsl:template match="ogt:Category" mode="path">
        <a href="&home;{$prefs}{$cstate}{$lstate}{$pstate}{$kstate}&amp;n={java:net.URLEncoder.encode(@ogt:catid)}&amp;g=c{java:net.URLEncoder.encode(@ogt:catid)}">
            <xsl:value-of select="@rdfs:label"/>
        </a> &gt;
        <xsl:apply-templates mode="path" select="ogt:subCategories"/>
    </xsl:template>

    <!-- Keyword path  -->
    <xsl:template match="ogt:Category" mode="keywordPath" name="keywordPath">
        <xsl:value-of select="@rdfs:label"/>
        &gt;
    </xsl:template>
    

	<xsl:template name="help">
		<p><strong>Valitse kategoria tai anna hakusana/hakusanoja.</strong></p>
		<p>Tähän logoja ja muuta hypetystä.</p>
	</xsl:template>
</xsl:stylesheet>
